Micro Focus Relativity DBA for Windows

Welcome to Relativity

  • Product Overview
  • Getting Started

Resources

  • Micro Focus Community Forum
  • Micro Focus Channel on YouTube
  • Micro Focus Customer Support
  • Software Licenses and Downloads
  • Micro Focus Knowledge Base
  • Micro Focus Training Store
Provide feedback

Provide feedback

  • Contacting Micro Focus
  • Email us feedback regarding this Help


Relativity Overview

The Relativity product set enables the construction of a true relational database using existing COBOL application data. Relativity provides a full-featured, Windows Open Services Architecture (WOSA), Open Database Connectivity (ODBC)-compliant relational database engine. Thus, Relativity allows SQL-based client access to COBOL application data without moving, converting, replicating, or re-engineering COBOL data files.

With Relativity providing SQL-based access to COBOL data files, any ODBC-enabled client/server development application or tool can be chosen to build applications for ad hoc reporting, decision support, and specialized data processing functions. Relativity enables any working application to benefit from client/server technology without rewriting or migrating that application.

The Relativity product set consists of three main software components:

  • Relativity Designer
  • Relativity DBA
  • Relativity Database Management System
Parent topic: Micro Focus Relativity DBA for Windows


Relativity Designer

The Relativity Designer is an interactive, Windows-based tool that enables the COBOL application developer to define and maintain a relational database system of tables using COBOL data.

The Relativity Designer creates the Relativity catalog by performing the following functions:

  • Automatically extracts the definitions of data files from the COBOL programs into the Relativity catalog.
  • Collects information regarding the data from the application developer.
  • Allows the developer to define relational tables from existing COBOL data items within records of existing COBOL files.

If an owner group has been assigned to the catalog, only users who are members of that owner group may open the data source associated with the catalog using the Relativity Designer. Assignment of an owner thus protects the sensitive data in the catalog exposed by the Relativity Designer from access by users who are not owners. A password-protected log on procedure validates user identities whenever a Relativity data source is opened, as explained in Providing Data Security.

Parent topic: Relativity Overview
Related concepts
Relativity DBA
Relativity Database Management System


Relativity DBA

The Relativity DBA (Database Administrator) is an interactive, Windows-based tool that enables the system administrator at the end-user location to maintain and manage the Relativity database and the security of the Relativity database.

The Relativity DBA provides the following functions:

  • Defining and authorizing users of the database.
  • Restricting the view of the data for individual groups of users.
  • Maintaining the linkages between tables and physical COBOL data files.
  • Defining date constants.
  • Merging security and connection information into a new catalog (an optional function controlled by the catalog developer).
  • Producing reports on security and connections.

The Relativity DBA can be used only by users who have the Use Administrator privilege set for the catalog, or by the catalog owner (who has all privileges set by default). The owner may grant this privilege to one or more administrative groups - see Defining Group Privileges.

Parent topic: Relativity Overview
Related concepts
Relativity Designer
Relativity Database Management System
Related reference
Defining Group Privileges


Relativity Database Management System

The Relativity Database Management System (DBMS) connects Windows client-based tool products to COBOL data files. It processes SQL requests from the ODBC-enabled application (or tool) and performs the necessary actions to respond to the request with data obtained from the COBOL data files.

The Relativity DBMS comes in two variants: single-tier and a client/server. The single-tier product is named the Relativity Data Manager. The client/server product is named the Relativity Data Client and Relativity Data Server.

Relativity Data Manager

The Relativity Data Manager is a single-tier version of the Relativity DBMS. By single-tier, we mean that the product is installed on a single machine. In this configuration, the COBOL data files are installed on the same machine as the ODBC-enabled application and the Relativity Data Manager.

Relativity Data Client and Relativity Data Server

The Relativity Data Client and Relativity Data Server are a client/server version of the Relativity DBMS. In this configuration, the COBOL data files are typically not on the same machine as the ODBC-enabled application. In this case, the Relativity Data Client is installed on the same machine as the ODBC-enabled application, and the Relativity Data Server is installed on the same machine as the COBOL data files. The Data Server needs to be installed only once and on only the server machine, that is, the machine with the COBOL data files. The Data Client needs to be installed on each client machine that needs access to the data on the server machine. The Data Client sends the SQL requests from the ODBC-enabled application to the Data Server, which then processes the requests and returns only the resulting rows to the Data Client, which in turn returns them to the ODBC-enabled application.

Parent topic: Relativity Overview
Related concepts
Relativity Designer
Relativity DBA


Micro Focus End User License Agreement

IMPORTANT: LICENSOR PROVIDES LICENSED SOFTWARE TO LICENSEE UNDER THIS END USER LICENSE AGREEMENT (THE “AGREEMENT”). THIS AGREEMENT GOVERNS LICENSEE’S INSTALLATION AND USE OF THE VERSION OF THE LICENSED SOFTWARE IDENTIFIED IN THE APPLICABLE PRODUCT ORDER, OR IF NOT ACQUIRED VIA A PRODUCT ORDER, LICENSEE’S INSTALLATION OR USE OF THE LICENSED SOFTWARE CONSTITUTES ACCEPTANCE OF THIS AGREEMENT. THE TERMS AND CONDITIONS OF THIS AGREEMENT MAY BE DIFFERENT FROM THE AGREEMENT(S) THAT ACCOMPANIED EARLIER RELEASES OF THE LICENSED SOFTWARE. PLEASE READ THIS AGREEMENT CAREFULLY BEFORE PROCEEDING, AS IT MAY CONTAIN ADDITIONAL RESTRICTIONS ON YOUR USE OF THE SOFTWARE. THIS AGREEMENT SUPERSEDES AND CONTROLS OVER ANY OTHER TERMS PROVIDED TO LICENSEE REGARDING LICENSEE’S USE OF THE LICENSED SOFTWARE, WHETHER WRITTEN OR ORAL, AS PART OF A SIGNED AGREEMENT (INCLUDING, BUT NOT LIMITED TO, MASTER AGREEMENTS AND PORTFOLIO TERMS, UNLESS A DIFFERENT AGREEMENT IS EXPRESSLY REFERENCED IN A PRODUCT ORDER OR EXECUTED BY LICENSOR AND LICENSEE SPECIFYING THAT IT APPLIES TO THE VERSION OF THE LICENSED SOFTWARE TO WHICH THIS AGREEMENT RELATES), A CLICK-WRAP AGREEMENT PROVIDED WITH THE LICENSED SOFTWARE OR OTHERWISE (SUCH TERMS REFERRED TO AS THE “OTHER AGREEMENT”), EVEN IF SUCH OTHER AGREEMENT WAS EMBEDDED WITHIN PREVIOUSLY LICENSED SOFTWARE. LICENSOR RESERVES THE RIGHT TO UPDATE, AMEND, AND/OR MODIFY THIS AGREEMENT FROM TIME TO TIME, AND MAY INCLUDE SUCH UPDATED AGREEMENT WITH OR EMBEDDED IN FUTURE VERSIONS OF THE LICENSED SOFTWARE. PLEASE DIRECT ANY QUESTIONS TO THE MICRO FOCUS LEGAL DEPARTMENT AT LEGALDEPT@MICROFOCUS.COM.

ENTERING INTO THIS AGREEMENT DOES NOT CONSTITUTE A SALES TRANSACTION. THE SALE OF A LICENSE TO SOFTWARE PRODUCTS TAKES PLACE UNDER PRODUCT ORDERS WHICH (UNLESS OTHERWISE STATED IN THE PRODUCT ORDER) INCORPORATE THE TERMS OF THIS AGREEMENT.

Capitalized terms in this Agreement are defined as follows:

"Additional License Authorization" or " ALA " means the additional specific software license terms that govern the authorized use of a given software product of Licensor, including requirements for any non-production use rights described in the Non-Production Licensing Guide, and License Options available for that software product, along with additional terms or conditions applicable to a given License Option, all of which are made a part of this Agreement. The applicable Additional License Authorization for the Licensed Software is either attached hereto or can be found here: https://software.microfocus.com/en-us/about/software-licensing by product name and version; all references in this Agreement to "Additional License Authorization" or "ALA" shall refer to the ALA that corresponds to the version of the Licensed Software.

"Documentation" means the user documentation that Licensor makes available for the Licensed Software in electronic form or paper form.

"Licensee" means the legal entity or individual that is identified in the applicable Product Order or who has rightfully received a license to the Licensed Product.

"License Option" means the type of license available for a given software product (such as a named user license, concurrent user license or server license). In addition to the ALA, a License Option may be set forth in a Product Order or an agreement executed in writing by Licensee and Licensor.

"Licensor" means the applicable Micro Focus entity and its affiliates who own the intellectual property rights in Licensed Product.

"Licensed Product" means the Licensed Software and Documentation.

"Licensed Software" means the executable version of Licensor's software listed in the Product Order or otherwise provided to or rightfully acquired by Licensee. This Agreement shall govern the use of any update to the Licensed Software that Licensee receives pursuant to a separate support and maintenance agreement as described in Section 4 below, unless such update contains, comes with, or is otherwise specifically governed by a different end user license agreement.

"Product Order" means an agreement between Licensor and Licensee that consists of a document that has been (i) submitted by Licensee describing the License Option(s) to be purchased for the Licensed Software, and (ii) accepted by Licensor (a) in writing or (b) by delivering the Licensed Software to Licensee, whichever occurs first. A Product Order may also consist of a written quote, or other written document issued by Licensor (the "Quote"), (i) describing the License Options for the Licensed Software to be purchased, and (ii) that is accepted by Licensee before the Quote expires either by (a) returning the Quote signed by an authorized representative of Licensee, (b) issuing a purchase order that references the Quote (if the Quote expressly allows acceptance in this manner), or (c) paying Licensor the fees listed in the Quote. Unless otherwise expressly set forth in the relevant Product Order, each Product Order incorporates the terms and conditions of this Agreement, and in no event will any different or additional terms of a purchase order or similar document issued by Licensee in connection with this Agreement or a Product Order apply, and any such additional or different terms are hereby rejected by the Licensor. For purposes of this paragraph, "Licensor" shall also include the relevant Micro Focus entity as defined above and its authorized distributors and resellers. Any conflicting or additional terms in a Product Order accepted by an authorized distributor or reseller of Licensor shall have no effect unless such terms have been agreed to by the applicable Micro Focus entity in writing.

"Third Party Component" means any run time or other elements owned or licensed to Licensor by a third party (other than open source code or elements) which may be embedded in the Licensed Software.

"Third Party Software" means additional or accompanying software owned or licensed by a third party (such as Adobe Acrobat or Microsoft Internet Explorer, but not any open source code or elements) that may be specified in the Documentation or in a file accompanying such Licensed Software .

"Warranty Period" means the ninety (90) day time frame beginning on date of delivery of the Licensed Software to Licensee (Licensed Software delivery is deemed to occur when the Licensed Software is physically delivered to Licensee EXWORKS or made available for download to Licensee).

  1. GRANT OF LICENSE; LICENSE CONDITIONS.

    1. License Grant. Subject to Licensee's compliance with the terms and conditions of this Agreement (including but not limited to payment of applicable fees), Licensor grants to Licensee a personal, non-transferable, non-sublicensable and non-exclusive license to use the Licensed Software as authorized by the License Option(s) specified in the ALA solely for Licensee's internal business operations, functions and benefit, and not for commercialization of the Licensed Software or to provide services or benefit to any affiliates or subsidiaries of Licensee or any other third party. Throughout the license term, Licensee agrees to: (i) implement internal safeguards to prevent any unauthorized copying, distribution, installation, use of, or access to, the Licensed Products and associated support and maintenance, or any other breach of this Agreement; and (ii) take all necessary steps to destroy or erase all Licensed Software codes, programs, Documentation, and other proprietary information of Licensor before disposing of any media or hardware. Licensor will provide any license key necessary for activation and use of the Licensed Software. Licensor is not liable or responsible for lost or broken license keys and is not obligated to replace license keys or issue new license keys unless (1) Licensee has purchased a support and maintenance plan for the applicable Licensed Software that specifically covers the issuance of new or replacement keys and (2) the applicable version of the Licensed Software is then generally available for distribution by Licensor. If Licensee has not paid for such a support and maintenance plan, replacement or new license keys may be available for purchase at Licensor's then-current list price for applicable new licenses

    2. Evaluation Licenses. With respect to any Licensed Software provided to Licensee solely for evaluation purposes (an "Evaluation License"), in the event of conflict this Section 1.B shall prevail over any other provisions set forth in this Agreement. An Evaluation License may be used for a period of no more than thirty (30) days from the date the Licensed Software is provided to Licensee ("Evaluation Term"), unless a different period is specified in writing by Licensor. An Evaluation License may be used solely for Licensee's internal evaluation and testing purposes on a single computer system and not for development, commercial, or production purposes. For Licensed Software subject to an Evaluation License, (i) Licensee may not reproduce or distribute the Licensed Products; and (ii) Licensee's results of benchmark or other performance tests run on or using the Licensed Software may not be disclosed to any third party without Licensor's prior written consent. At any time during the Evaluation Term or upon completion thereof, Licensee may, upon written notification to Licensor and payment of the applicable license fee, replace the Evaluation License with a license to use the Licensed Software that is not restricted to evaluation purposes. In the absence of such notification by Licensee, the Evaluation License shall automatically terminate at the end of the Evaluation Term, and Licensee shall return, or, if Licensor so directs, delete and destroy all such Licensed Software and provide Licensor with written confirmation of its compliance with this provision. Upon written request from Licensee, Licensor may, in its sole discretion, grant Licensee an extension in writing prior to the expiration of the Evaluation Term. Other than updates to Licensed Software provided as part of support and maintenance, Licensed Software provided by Licensor free of license fee charge shall be deemed to be provided for evaluation purposes only. Licensed Software furnished under an Evaluation License is provided without any contractual obligation of maintenance and support by Licensor and is provided "as is" without warranties, implied or express, of any kind

    3. Bundles/Suites. If the Licensed Software is licensed in a bundle or suite of multiple products, and the applicable Product Order specifies the License Option and license count for the bundle or suite (but not the individual product components of the bundle or suite), then each product in the bundle or suite shall share such license type and count. For example, individual products in the bundle or suite cannot be used by multiple users if only one user license is purchased (for user-based licenses) and cannot be installed on multiple devices or servers if only one device or server license is purchased (for device or server-based licenses).

  2. USE RESTRICTIONS. Except as may be otherwise specifically permitted in the applicable ALA, Licensee agrees not to, directly or indirectly:
    1. Copy, distribute or use the Licensed Software, in whole or in part (such as any portion, feature, function, or user interface) without paying Licensor the applicable fees;
    2. Use the Licensed Software as a service, or for timesharing, facilities management, outsourcing, hosting, service bureau use, or for providing other application service (ASP) or data processing services to third parties or for like purposes, or permit the use of the Licensed Software by a third party or permit access by or use for the benefit of any third party without executing a separate distribution agreement for the Licensed Software and paying Licensor the applicable required additional fees;
    3. Modify or create derivative works of the Licensed Software, or decrypt, translate, disassemble, recompile, decompile or reverse engineer the Licensed Software or attempt to do so (except to the extent applicable law specifically permits such activity, in which case Licensee must provide Licensor with detailed information regarding such activities);
    4. Alter, destroy, or otherwise remove any proprietary notices or labels on or embedded within the Licensed Software;
    5. Use the Licensed Software in a manner other than as specifically permitted in this Agreement or an ALA;
    6. Assign, sell, resell, license, rent, lease, lend, sublicense, outsource or otherwise transfer the Licensed Software to any third party, without first paying Licensor the applicable required license fees and obtaining Licensor's prior written consent;
    7. Authorize, allow or appoint any third party to do any of the foregoing. For the avoidance of doubt, third parties include, without limitation, contractors and consultants (including contractors and consultants retained to provide services solely for the benefit of Licensee), outsourcers, Licensee's affiliates and subsidiaries, parent companies, customers, and the public; or
    8. Publish or disclose to third parties any evaluation or benchmarking of the Licensed Software without Licensor's prior written consent.

      Notwithstanding the foregoing, Licensee may: (i) make a reasonable number of archival back-up copies of the Licensed Software and (ii) make a reasonable number of copies of the Documentation. Licensee shall reproduce all copyright and other proprietary rights notices appearing in or on the Licensed Products, including notices of all third party suppliers.

  3. TERM OF LICENSE. This Agreement and the license term for the Licensed Software granted herein is perpetual, unless a subscription/term license has been purchased by Licensee (in which case the license term shall be set forth in the Product Order or ALA), and is subject to earlier termination as provided in this Section 3. If Licensee has purchased a subscription/term license, such license shall automatically terminate upon expiry of such subscription/term, unless earlier terminated under this Section 3. Licensor may terminate this Agreement, along with any or all licenses then in effect with Licensee, immediately by giving Licensee written notice of termination in the event that (i) Licensee breaches any term or condition of this Agreement and fails to remedy such breach within ten (10) days of receipt of Licensor's notice detailing such breach; (ii) Licensee becomes insolvent, has a receiver appointed, or files for or has filed against it, liquidation, bankruptcy or analogous proceedings; or (iii) Licensee infringes or misappropriates the intellectual property rights of Licensor. Termination shall be without prejudice to any other rights or remedies Licensor may have. In the event of any termination, Licensee's license(s) to install, access or use the Licensed Software will immediately terminate, and Licensee shall destroy and erase all copies of such Licensed Software in its possession or control and provide written certification to Licensor that it has complied with this provision. Early termination of this Agreement shall not entitle Licensee to any refund or reimbursement of any previously paid fees. The rights and obligations of the parties contained in Sections 3 (Term of License), 6 (Disclaimer of Warranty), 7 (Limitation of Liability), 8 (High Risk Uses), 9 (Ownership), 10 (Third Party Software and Components), 11 (Notice to U.S. Government End Users), 12 (License Fees and Payment Terms), 13 (Audits), 15 (Privacy and Use of Licensee Information),16 (Licensee Trademark and Feedback) and 17 (Miscellaneous) will survive the termination or expiration of this Agreement.
  4. SUPPORT AND MAINTENANCE. Licensee is not entitled to any updates to the Licensed Software, unless Licensee purchases maintenance and support services pursuant to Licensor's then-current applicable standard maintenance and support agreement, which can be found at https://www.microfocus.com/support-and-services/maintenance-and-support-agreements/ or can be provided by Licensor at Licensee's request. Maintenance and support services (including, but not limited to, any new versions, bug fixes, and patches) provided by Licensor will be subject to such agreement. Where Licensee purchases maintenance and support for any Licensed Software, Licensee hereby agrees to purchase or keep current on such maintenance and support services for all of Licensee's licensed units of such Licensed Software product, regardless of License Option.
  5. LIMITED WARRANTY. Licensor warrants for the Warranty Period that: (i) if the Licensed Software is supplied via media, the media will be free from defects in materials or workmanship under normal use, and (ii) the copy of the Licensed Software delivered to Licensee substantially conforms in all material respects to the Documentation. Licensee's sole and exclusive remedy for any defective media supplied by Licensor shall be Licensor's repair or replacement of such defective media free of charge, provided that the defective media is returned to Licensor during the Warranty Period. During the Warranty Period, Licensee's sole and exclusive remedy for not meeting part (ii) of the above warranty shall be the repair or replacement of the Licensed Software by Licensor free of charge so that it substantially conforms to the Documentation or, if Licensor reasonably determines that such remedy is not economically or technically feasible, Licensee shall be entitled to a full refund of the license fee and any maintenance fee paid for such Licensed Software. Upon such refund, Licensee's license to use such Licensed Software will immediately terminate. The warranties set forth in this Section 5 shall not apply if the defects in the Licensed Software or media result from: (a) failure to use the Licensed Software in accordance with the Documentation, this Agreement or ALAs; (b) the malfunctioning of Licensee's equipment or network; (c) accident, neglect, or abuse; (d) service by any unauthorized person; (e) other software used by Licensee and not provided by Licensor, or for which the Licensed Software is not designed or licensed for such use; (f) Third Party Software that is not a Third Party Component; (g) any other cause occurring after initial delivery of the Licensed Software or media to Licensee, unless caused directly by Licensor. Licensor has no responsibility for any claims made outside of the Warranty Period. The foregoing warranty shall not apply to any free-of-charge Licensed Software or updates provided under support and maintenance. THE FOREGOING WARRANTIES DO NOT APPLY, AND LICENSOR DISCLAIMS ALL WARRANTIES, WITH RESPECT TO ANY THIRD PARTY SOFTWARE THAT IS NOT A THIRD PARTY COMPONENT. The warranties set forth in this Section 5 will not apply and will become null and void if Licensee materially breaches any provision of this Agreement.
  6. DISCLAIMER OF WARRANTY. EXCEPT FOR THE LIMITED WARRANTY SET FORTH IN SECTION 5, THE LICENSED PRODUCTS ARE PROVIDED TO LICENSEE "AS-IS" WITHOUT WARRANTY OF ANY KIND. LICENSOR DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED IN THE LICENSED SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS, THAT OPERATION WILL BE UNINTERRUPTED, ACHIEVE ANY INTENDED RESULT, BE COMPATIBLE, OR WORK IN COMBINATION WITH ANY OTHER SOFTWARE, APPLICATIONS, OR SYSTEMS, MEET ANY PERFORMANCE OR RELIABILITY STANDARDS, OR BE ERROR FREE, OR THAT ANY ERRORS OR DEFECTS CAN OR WILL BE CORRECTED. EXCEPT AS SET FORTH HEREIN AND TO THE EXTENT PERMITTED BY LAW, ALL OTHER WARRANTIES WITH RESPECT TO THE LICENSED PRODUCTS, WHETHER EXPRESS OR IMPLIED, STATUTORY OR OTHERWISE, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, NON-INFRINGEMENT, AND WARRANTIES THAT MAY ARISE OUT OF COURSE OF DEALING, COURSE OF PERFORMANCE, USAGE, OR TRADE PRACTICE ARE EXPRESSLY DISCLAIMED BY LICENSOR AND ITS THIRD-PARTY SUPPLIERS AND AFFILIATES. LICENSEE ACKNOWLEDGES THAT LICENSEE IS RESPONSIBLE FOR THE SELECTION OF THE LICENSED SOFTWARE TO ACHIEVE LICENSEE'S INTENDED RESULTS AND FOR THE INSTALLATION AND/OR USE OF, AND RESULTS OBTAINED FROM, THE LICENSED SOFTWARE.
  7. LIMITATION OF LIABILITY.
    1. Aggregate Cap. IN NO EVENT SHALL ANY LIABILITY OF LICENSOR OR ITS AFFILIATES OR ANY OF ITS OR THEIR RESPECTIVE LICENSORS OR SERVICE PROVIDERS UNDER OR IN CONNECTION WITH THIS AGREEMENT EXCEED, IN THE AGGREGATE, THE AMOUNTS PAID BY LICENSEE FOR THE LICENSED SOFTWARE AND THE INITIAL PERIOD OF MAINTENANCE AND SUPPORT GIVING RISE TO THE APPLICABLE CLAIM.
    2. Waiver of Liability. IN NO EVENT SHALL LICENSOR OR ITS AFFILIATES OR ANY OF ITS OR THEIR RESPECTIVE LICENSORS OR SERVICE PROVIDERS BE LIABLE FOR ANY INDIRECT, SPECIAL, INCIDENTAL, CONSEQUENTIAL, PUNITIVE OR SIMILAR DAMAGES, LOSS OF PROFITS, BUSINESS, DATA, OR PROGRAMS (INCLUDING, BUT NOT LIMITED TO, THE COST OF RECOVERING OR REPLACING SUCH DATA OR PROGRAMS), LOSS, DAMAGE OR ANY COSTS DUE TO INTERRUPTION, DELAY, OR INABILITY TO USE THE LICENSED SOFTWARE, WHETHER ARISING OUT OF OR IN CONNECTION WITH THIS AGREEMENT, EVEN IF INFORMED OF THE POSSIBILITY OF SUCH DAMAGES IN ADVANCE.
    3. Scope. THE LIMITATIONS AND EXCLUSIONS OF THIS SECTION 7 APPLY TO ALL CAUSES OF ACTION, INCLUDING, WITHOUT LIMITATION, BREACH OF CONTRACT, BREACH OF WARRANTY, NEGLIGENCE, STRICT LIABILITY, MISREPRESENTATION AND OTHER TORTS. THESE LIMITATIONS AND EXCLUSIONS APPLY COLLECTIVELY TO LICENSOR, ITS PARENTS, AFFILIATES, AND SUBSIDIARIES AND EACH OF THEIR RESPECTIVE EMPLOYEES, CONTRACTORS, AND SUPPLIERS. NOTWITHSTANDING THE FOREGOING, NOTHING IN THIS SECTION 7 EXCLUDES LIABILITY FOR WILLFUL MISCONDUCT OR FRAUDULENT MISREPRESENTATION.
    4. Exclusive Remedy. LICENSEE’S REMEDIES IN THIS AGREEMENT ARE LICENSEE’S EXCLUSIVE REMEDIES. LICENSEE AGREES THAT, IN ENTERING INTO THIS AGREEMENT, IT DID NOT RELY ON ANY REPRESENTATIONS (WHETHER WRITTEN OR ORAL) OF ANY KIND OTHER THAN THOSE EXPRESSLY SET OUT IN THIS AGREEMENT.
    5. Essential Purpose. LICENSEE FURTHER ACKNOWLEDGES THAT THE LIMITATIONS AND EXCLUSIONS OF LIABILITY IN THIS SECTION 7 APPLY TO THE FULLEST EXTENT PERMITTED BY LAW AND ARE AN ESSENTIAL ELEMENT OF THIS AGREEMENT AND THAT, IN THE ABSENCE OF SUCH LIMITATIONS AND EXCLUSIONS, THE PRICING AND OTHER TERMS AND CONDITIONS SET FORTH HEREIN WOULD BE SUBSTANTIALLY DIFFERENT. THE LIMITATIONS AND EXCLUSIONS SET FORTH IN THIS SECTION 7 SHALL APPLY EVEN IF THE LICENSEE’S REMEDIES UNDER THIS AGREEMENT FAIL OF THEIR ESSENTIAL PURPOSE.
    6. Free Software. IF LICENSOR PROVIDES LICENSEE WITH ANY LICENSED SOFTWARE FREE-OF-CHARGE OR UNDER AN EVALUATION LICENSE, TO THE EXTENT PERMITTED BY LAW, LICENSOR SHALL NOT BE RESPONSIBLE FOR ANY LOSS OR DAMAGE TO LICENSEE, ITS CUSTOMERS, OR ANY THIRD PARTIES CAUSED BY THE LICENSED SOFTWARE THAT IT MAKES AVAILABLE TO LICENSEE.
  8. HIGH RISK USES. The Licensed Software is not fault tolerant, nor designed, manufactured, or intended for use in hazardous environments requiring fail-safe performance (including, without limitation, the operation of nuclear facilities, aircraft navigation or communication systems, air traffic control, direct life support machines, or weapons systems) in which failure of the Licensed Software could lead directly or indirectly to death, personal injury, or severe physical or environmental damage. Licensor and its suppliers shall have no liability for any use of the Licensed Software in any high-risk situations.
  9. OWNERSHIP. The Licensed Products are provided under license, and not sold, to Licensee. The only rights in the Licensed Products are the licenses expressly stated in this Agreement and no other rights are implied or granted by estoppel. Licensor (and its affiliates) and its and their licensors and third party suppliers retain ownership of, and reserve all rights in and to, the Licensed Products, including all copies thereof, and all intellectual property rights arising out of or relating to the Licensed Products. Licensee shall use reasonable efforts to safeguard the Licensed Products (including all copies thereof) from infringement, misappropriation, theft, misuse, or unauthorized access. Licensee shall promptly notify Licensor if it becomes aware of any infringement or misappropriation of the Licensed Products and shall fully cooperate with Licensor, at Licensor's expense, in any legal action taken by Licensor to enforce its intellectual property rights.
  10. THIRD PARTY SOFTWARE AND COMPONENTS. The Licensed Software may come with or require Third Party Software that Licensee shall license directly from the third party licensor pursuant to such third party's terms and conditions and not this Agreement. Additionally, some Licensed Software may include certain Third Party Components and open source software. Such open source software and Third Party Components may also be loaded on the Licensed Software media. Third Party Components are licensed to Licensee under this Agreement; open source software is licensed pursuant to the applicable open source license. To the extent applicable, information about the open source software may be found (i) in a file accompanying the applicable Licensed Software or (ii) in the Documentation or ALA. Licensee shall not directly access any Third Party Components other than with or as part of the Licensed Software. Licensee agrees that to the extent required by a third party licensor or supplier of a Third Party Component, that third party licensor or supplier is an intended third party beneficiary of this Agreement as necessary to protect intellectual property rights in the Licensed Software and limit certain uses thereof.
  11. NOTICE TO U.S. GOVERNMENT END USERS. The Licensed Products are deemed to be "Commercial Items," as defined at 48 C.F.R. §2.101, consisting of "Commercial Computer Software" and "Commercial Computer Software Documentation," as such terms are used in 48 C.F.R. §12.212 or 48 C.F.R. §227.7202, as applicable. Consistent with such sections, the Licensed Products are licensed to U.S. Government end users (i) only as Commercial Items, and (ii) with only those rights as are granted pursuant to this Agreement.
  12. LICENSE FEES AND PAYMENT TERMS. Licensee agrees to pay the applicable license fees for the Licensed Products within thirty (30) days of the date of invoice or such other date as agreed in writing by the parties. Software license fees are non-refundable, except as provided in Section 5 above, and shall be paid without any deduction or tax withholding. Software License fees are exclusive of any applicable transportation charges, sales, use, value added tax, and other applicable taxes and duties, and all such amounts shall be paid or reimbursed by Licensee. Licensee shall be liable for all outstanding past due amounts, which shall accrue interest at the rate of 1.5% per month compounded or, if lower, the maximum rate allowed by applicable law, and any collection costs associated with the collection of any past due amounts.
  13. AUDITS. Licensor or an Auditor (as defined below) has the right to verify Licensee’s compliance with the licenses issued under Product Orders, the applicable ALAs and this Agreement (please see Micro Focus License Compliance Charter at http://supportline.microfocus.com/licensing/licVerification.aspx, which can also be provided by Licensor at Licensee’s request). Licensee agrees to:
    1. Recordkeeping. Keep, and upon Licensor’s request, provide records, sufficient to certify Licensee’s compliance with this Agreement based on the applicable License Option(s) (including applicable license metric and other terms and conditions) for the Licensed Software, which may include but are not limited to, serial numbers, license keys, logs, the location, model (including quantity and type of processor) and serial number of all machines on which the Licensed Software is installed or accessed or from which the Licensed Software can be accessed, the names (including corporate entity) and number of users accessing or otherwise able to access the Licensed Software, metrics, reports, copies of the Licensed Software (by product and version), and network architecture diagrams as they may relate to Licensee’s licensing and deployment of the Licensed Products and associated support and maintenance;
    2. Questionnaire. Within seven (7) days of Licensor’s request, Licensee shall furnish to Licensor or its designated independent auditor (“Auditor”) a completed questionnaire provided by Licensor or Auditor, accompanied with a written statement signed by a director of Licensee certifying the accuracy of the information provided; and
    3. Access. Provide representatives of Licensor or Auditor any necessary assistance and access to records and computers to allow an inspection and audit of Licensee’s computers and records, during Licensee’s normal business hours, for compliance with licenses, the applicable ALAs, and this Agreement, and fully cooperate with such audit.
    4. Non-Compliance. In the event that Licensee has, or at any time has had, unlicensed installation, use of, or access to the Licensed Software or has otherwise breached this Agreement or an ALA (a “Non-Compliance”), without prejudice to any other rights or remedies Licensor may have, including, without limitation, injunctive relief, Licensee shall, within thirty (30) days’ notice of such Non-Compliance to Licensee, purchase sufficient licenses and/or subscriptions and associated support and maintenance to cure the Non-Compliance, by paying Licensor’s current (as of the date of such additional purchase) list license fees and 12-month support and maintenance fees to Licensor for such additional licenses, plus Licensor’s current (as of the date of such additional purchase) list term license and support and maintenance fees and interest (compounded at 1.5% monthly or the maximum rate permitted by applicable law if lower) for such additional licenses for the time period from the commencement of the Non-Compliance until payment of the aforementioned fees, with interest payable even if an invoice was not issued at the time the Non-Compliance occurred. For purposes of the foregoing, “list” shall mean Licensor’s full list price as set forth in Licensor’s standard price list that is current as of the commencement of the audit without any volume or other discount. If Licensee’s Non-Compliance results in an underpayment of license fees of 5% or greater, Licensee shall also reimburse Licensor for the reasonable cost of such audit in addition to other amounts due. In the event of a dispute related to a Non-Compliance, Licensor shall have the right to collect from Licensee its reasonable costs and attorneys' fees incurred in enforcing this Agreement.
  14. RELATED SERVICES. Licensee shall be responsible for obtaining and installing all proper hardware and other third party support software (including operating systems) for the proper installation and implementation of the Licensed Software. In the event that Licensee retains Licensor to perform any services with respect to the Licensed Software (for example: installation, implementation, maintenance, consulting, or training services), Licensee and Licensor agree that such services shall be provided at Licensor’s then- current standard terms, conditions, and rates for such services unless otherwise agreed in writing by Licensor.
  15. PRIVACY AND USE OF LICENSEE INFORMATION.
    1. Responsibility and Compliance with Laws. Licensee is solely responsible for and assumes all liability with respect to its own collection, processing, storage, and transfer of any user data, including, but not limited to, personally identifiable information and personal health and financial information (collectively, “Personal Information”). Licensee shall be solely responsible for notifying its users of proper use of such data. Each party is responsible for complying with its respective obligations under all applicable laws, regulations, and industry standards regarding data collection and data privacy applicable for the use of the Licensed Software by the relevant party.

      Licensee shall not provide any Personal Information to Licensor for processing by Licensor on behalf of Licensee, unless otherwise agreed by the parties in writing in an applicable transaction document with applicable privacy terms. If the parties agree that processing Personal Information is necessary for the performance of this specific transaction, and when such Personal Information processing falls within the scope of the General Data Protection Regulation (EU) 2016/679 (“GDPR”), before any Personal Information is made available to Licensor, the parties agree that Licensee will be the data controller and Licensor will be the data processor, and when Licensor is processing Personal Information on behalf of Licensee, such processing shall be governed by terms that comply with Article 28 of the GDPR including standard contractual clauses to be included in such transaction document.

      Licensor will not have access to protected health information unless the parties have an executed business associate agreement in place for this transaction. Licensee is solely responsible for assessing the Licensed Product or any related product or service for compliance with any industry requirements applicable to Licensee.

    2. Consent to Use of Licensee Information. To the extent required or permitted by law, Licensee hereby expressly consents to (i) receiving information from Licensor from time to time advertising Licensor’s products; (ii) the use of Licensee’s name in Licensor customer lists, promotional materials, and press releases; and (iii) the collection and use of information about the computer system on which the Licensed Software is installed (e.g. product version, serial number) for internal security and licensing purposes. Further information about Licensor’s processing of personally identifiable data is available at https://www.microfocus.com/about/legal/#privacy (click “Privacy Notice” tab) or can be provided by Licensor at Licensee’s request.
    3. Other Use of Licensee Information. To the extent required or permitted by law, and notwithstanding the terms in Section 15.A, Licensor may also process personally identifiable information of Licensee and Licensee’s users (i) in order to comply with a legal obligation to which Licensor is subject; (ii) as is necessary for the performance of this Agreement; and (iii) where necessary for the purposes of Licensor’s legitimate interests, except where such interests are overridden by the interests or fundamental rights and freedoms of the Licensee or Licensee’s users which require protection of personally identifiable information.
  16. LICENSEE TRADEMARK AND FEEDBACK. Licensor may use Licensee’s name and logo for business development and marketing purposes, including, but not limited to, online and printed sales and marketing materials. Any other use of Licensee’s name or logo, or a description of Licensee’s use of the Licensed Software, shall be subject to Licensee’s prior consent. Any suggestions, ideas for modifications, enhancements, and other feedback from Licensee regarding the Licensed Software provided at any time (collectively, the “Feedback”), including (but not limited to) all intellectual property rights in and to such Feedback, shall be owned exclusively by Licensor. Licensee hereby assigns all right, title and interest in and to such Feedback and all the intellectual property rights therein to Licensor, without the necessity of any further consideration. To the extent any Feedback cannot be assigned to Licensor, Licensee hereby grants to Licensor a perpetual, irrevocable, exclusive, worldwide, royalty-free, fully paid up license, with the right to sublicense through multiple tiers to use, make, sell, distribute, execute, adapt, translate, reproduce, display, perform, modify, create derivative works of and otherwise exploit the Feedback in any manner.
  17. MISCELLANEOUS.
    1. Assignment. Licensor may assign this Agreement, including any rights or obligations under the Agreement (in whole or in part) to a parent or an affiliate. Licensee may not assign or transfer this Agreement or any of its rights or duties hereunder, including (but not limited to) by merger, acquisition by any entity of all or substantially all of Licensee’s stock or assets, change of control, operation of law, or otherwise, without the prior written consent of Licensor and payment by Licensee of the applicable assignment fee. Any attempted assignment not in accordance with this Section shall be null and void.
    2. Governing Law. If Licensee is located in North America, the laws of the State of California govern this Agreement and the licenses granted hereunder, and the parties hereto consent to the exclusive jurisdiction of the State and Federal courts of the State of California in any action based on this Agreement or the Licensed Software hereunder or any License Option under an ALA. Each party waives any right it may have to object to such venue, including objections based on personal jurisdiction or forum non conveniens (inconvenient forum). The parties agree that the Uniform Computer Information Transaction Act or any version thereof, adopted by any state, in any form ("UCITA"), shall not apply to this Agreement. To the extent that UCITA is applicable, the parties hereby opt out of the applicability of UCITA pursuant to the opt-out provision(s) contained therein. If Licensee is located in France, Germany or Japan, this Agreement is governed by the laws of the country in which Licensee is located. In the rest of the world the laws of England govern this Agreement. In each case, the applicable law shall apply without regard to conflict of laws provisions thereof, and without regard to the United Nations Convention on the International Sale of Goods. Other than for North American transactions, this Agreement, the licenses granted hereunder, and the parties hereto, shall be subject to the exclusive jurisdiction of the courts of the country determining the applicable law as aforesaid.
    3. Export Control. This Agreement may be subject to export control laws, regulations, and other restrictions of the United States (including, but not limited to, the U.S. Export Administration Regulations (the “EAR”)), United Kingdom, or the European Union regarding export or re-export of computer software and technology. Licensee agrees to comply with all applicable export control laws, regulations, and restrictions, including the EAR, where applicable.
    4. Entire Agreement. The applicable Product Order and this Agreement including the applicable ALA, constitutes the complete and exclusive statement of agreement between the parties relating to the license for the Licensed Products and supersedes all prior proposals, communications, purchase orders, and agreements (including, without limitation, Other Agreements), without need for a mutually executed amendment to any such Other Agreement. Any conflicting terms and conditions shall be resolved according to the following order of precedence: the applicable Product Order, the applicable ALA, and then this Agreement in all other respects.
    5. Amendment. No representation, supplement, modification, or amendment of this Agreement will be binding on either party unless executed in writing by duly authorized representatives of both parties (excluding any distributor or reseller of Micro Focus) to this Agreement.
    6. Waiver. No waiver of any right under this Agreement will be effective unless in writing and signed by authorized representatives of both parties (excluding any distributor or reseller of Licensor). No waiver of any past or present right arising from any breach or failure to perform will be deemed to be a waiver of any future right arising under this Agreement.
    7. Severability. If any provision in this Agreement is invalid or unenforceable, that provision will be construed, limited, modified or, if necessary, severed, to the extent necessary, to eliminate its invalidity or unenforceability, and the other provisions of this Agreement will remain unaffected.
    8. No Reliance. Each party acknowledges that in entering into this Agreement it has not relied on any representations, agreements, warranties or other assurances (other than those repeated in this Agreement) and waives all rights and remedies which but for this Section 17 would be available to it.


The Micro Focus Community

In addition to this product documentation, visit the to browse the Knowledge Base, read articles and blogs, as well as discuss this product with other users and Micro Focus specialists.


Contacting Micro Focus

Our Web site gives up-to-date details of contact numbers and addresses.

  • Further Information and Product Support
  • Information We Need
  • Creating Debug Files
Parent topic: Micro Focus Relativity DBA for Windows


Further Information and Product Support

Additional technical information or advice is available from several sources.

The product support pages contain a considerable amount of additional information, such as:

  • Product Updates on Software Licenses and Downloads, where you can download fixes and documentation updates.
    1. Log into the Software Licenses and Downloads (SLD) site at https://sld.microfocus.com/mysoftware/download/downloadCenter .
    2. Select your account and click Entitlements.
    3. Search for the product by using any of the available search parameters.
    4. Click Show all entitlements.
    5. Click Get Software in the Action column for the product you want to download or update.

      In the File Type column, you see entries for "Software" for any GA products, and "Patch" for any patch updates.

    6. Click Download on the relevant row.
  • The Examples and Utilities section of the Micro Focus Customer Care Web site, including demos and additional product documentation. Go to https://supportline.microfocus.com/examplesandutilities/index.aspx.
  • The Support Resources section of the Micro Focus Customer Care Web site, that includes troubleshooting guides and information about how to raise an incident. Go to https://supportline.microfocus.com/supportresources.aspx

To connect, enter https://www.microfocus.com/en-us/home/ in your browser to go to the Micro Focus home page, then click Support & Services > Support. Type or select the product you require from the product selection dropdown, and then click Support Login.

Note: Some information may be available only to customers who have maintenance agreements.

If you obtained this product directly from Micro Focus, contact us as described on the Micro Focus Web site, https://www.microfocus.com/support-and-services/contact-support/. If you obtained the product from another source, such as an authorized distributor, contact them for help first. If they are unable to help, contact us.

Also, visit:

  • The Micro Focus Community Web site, where you can browse the Knowledge Base, read articles and blogs, find demonstration programs and examples, and discuss this product with other users and Micro Focus specialists.
  • The Micro Focus YouTube channel for videos related to your product..
Parent topic: Contacting Micro Focus
Related information
Micro Focus SupportLine
Examples and Utilities
Support Resources
Micro Focus Community
White Papers and Webinars
Micro Focus YouTube Channel


Information We Need

However you contact us, please try to include the information below, if you have it. The more information you can give, the better Micro Focus Customer Support can help you. But if you don't know all the answers, or you think some are irrelevant to your problem, please give whatever information you have.

  • The name and version number of all products that you think might be causing a problem.
  • Your computer make and model.
  • Your operating system version number and details of any networking software you are using.
  • The amount of memory in your computer.
  • The relevant page reference or section in the documentation.
  • The product serial number . To find a serial number, look .
  • Your Relativity catalog and data files.
Parent topic: Contacting Micro Focus


Creating Debug Files

If you encounter an error when compiling a program that requires you to contact Micro Focus Customer Care, your support representative might request that you provide additional debug files (as well as source and data files) to help us determine the cause of the problem. If so, they will advise you how to create them.

Parent topic: Contacting Micro Focus


Getting Started

  • Starting and Stopping the Relativity DBA
    The Relativity DBA runs in Windows. Use this section for details on how to start and stop it properly.
  • Relativity Catalogs
    The function of a Relativity catalog is similar to that of the 'system catalog' in a relational database management system. It serves as a repository for information regarding the structure of relational tables.
  • Configuring Relativity Data Sources
    Microsoft's Open Database Connectivity (ODBC) interface requires that a data source be configured in order to allow data access.
  • Configuring the Workspace
    Configure the look and feel of Relativity DBA to suit the way that you work.
  • Setting Options
    Relativity allows you to specify default settings for various configuration preferences, including data sources, date formats, and COBOL types.
Parent topic: Micro Focus Relativity DBA for Windows


Starting and Stopping the Relativity DBA

The Relativity DBA runs in Windows. Use this section for details on how to start and stop it properly.
  • Starting the Relativity DBA
  • Exit the Relativity DBA
Parent topic: Getting Started


Starting the Relativity DBA

Windows 7 and earlier

To start the Relativity DBA, from your Windows desktop, click Start > All Programs > RMCOBOL > Relativity v12 > DBA.

Windows 10 and later

To start the Relativity DBA, from your Windows desktop, click Start > RM Relativity v12 > DBA.

Next you need to either create a new data source, or log on to an existing one.

Parent topic: Starting and Stopping the Relativity DBA
Related reference
Setting up a New Data Source
Opening an Existing Data Source


Exit the Relativity DBA

To exit the Relativity DBA:

  • On the File menu, click Exit.
  • Click Close (Close) on the title bar.
Parent topic: Starting and Stopping the Relativity DBA


Relativity Catalogs

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the query optimizer. Additionally, the Relativity catalog contains complete information regarding the physical COBOL data file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL data files and data elements, and the relational tables and their constituent columns. Finally, security information about users, groups, and privileges is stored in the catalog. Together, all of this information allows Relativity to present the COBOL data files through an ODBC interface of an ODBC-enabled application as a relational database of well-normalized tables substantially independent of the original COBOL data file structure of the application.

The Catalog Explorer pane is displayed in the Relativity DBA main window when a Relativity data source is opened. It displays the activities related to administering the Relativity database. Within the Catalog Explorer, lists of tables can be viewed and opened. User information also can be viewed and changed.

Parent topic: Getting Started
Related reference
Relativity DBA Window


Configuring Relativity Data Sources

Microsoft's Open Database Connectivity (ODBC) interface requires that a data source be configured in order to allow data access.

Configuring a data source involves setting the data source name (DSN) by which the data source will be known, optionally entering a textual description of the data source, entering any additional information required by a specific ODBC driver for connecting to the actual data, and setting any options supported by the specific ODBC driver. Data source configuration applies both to setting up a new data source or modifying an existing data source.

  • In single-tier (that is, non-client/server) versions of Relativity, the Data Manager data source can be configured within the Relativity DBA. In client/server versions of Relativity, only the Data Client data source can be configured within the Relativity DBA.
  • In client/server versions of Relativity, the Data Server data source is configured using the Relativity Server Administrator, a separate utility provided with the Relativity DBMS. The Data Client data source is subsequently associated with the Data Server data source from within the Relativity DBA.
Note: If you installed the Relativity Server Administrator utility, you can start this program from within the Relativity DBA by clicking Relativity Server Admin on the Tools menu. The Select Server dialog box is displayed. (For more information, see the Server Administrator Help file, which is available by clicking Help on the Select Server dialog box.)

Data source configuration also can be performed outside of Relativity, using the ODBC Administrator functions available on 32-bit Windows from the Windows Control Panel (see the Data Sources (ODBC) applet; under Administrative Tools in the Control Panel).

On a 64-bit Windows 7 machine, the ODBC Administrator will only be able to configure the 64-bit Data Sources of the 64-bit Data Client. In order to create 32-bit Data Sources for the Data Manager or the 32-bit Data Client, you must use the 32-bit ODBC Administrator program. Unfortunately, this program is not in the Windows Control Panel. You must run C:\Windows\SysWOW64\odbcad32.exe. (We recommend that you create a short-cut to this program on your desktop.)

On a 64-bit Windows 10 machine, the 32-bit ODBC Administrator program can be used directly. From the Start menu, select [image] (Settings). In the Windows Settings window, type ODBC in the Find a setting search box and select Set up ODBC data sources (32-bit).

The ODBC Administrator, a standard ODBC program, requires selection of a particular ODBC driver.

Note: The Relativity DBA allows easy and quick access to the ODBC Data Source Administrator. To start the program, click ODBC Control Panel or ODBC Control Panel (64-bit) on the Tools menu. The ODBC Data Source Administrator dialog box is displayed.

Since data source configuration is always specific to a selected ODBC driver, any method of starting the process requires that you complete the same tasks when configuring a Relativity data source. For more information about configuring a Relativity data source, choose one of the following tasks:

  • Single-tier and Client/Server Data Sources
  • Relativity Drivers
  • Setting up a New Data Source
  • Opening an Existing Data Source
  • Closing a Data Source
Parent topic: Getting Started


Single-tier and Client/Server Data Sources

One of the finer points of using Relativity is the distinction between single-tier and client/server data sources. For the Relativity Designer, a single-tier data source is needed when the COBOL data files reside on the same machine as the Relativity Designer. In this case, the Relativity Data Manager should be installed and the Relativity (*.rcg) driver should be used to create the data source.

However, when the COBOL data files reside on a different machine from the Relativity Designer, the Relativity Data Server must be installed on the machine with the COBOL data files, and the Relativity Data Client must be installed on the machine with the Relativity Designer. During the installation of the 32-bit Relativity Data Client, select a Custom Installation and on the Data Client Installation Type page, select Database Administrator.

Before a client data source is created, the server data source to which it will connect must exist. Start the Relativity Designer and, from the Tools menu, select Relativity Server Admin, and use this utility to create a server data source. After the server data source exists, then a client data source can be created that references the server data source. (See the Relativity Server Admin help file for more details on creating a server data source.)

Note: The server data source needs to be created only once. When the Relativity Data Client is installed on subsequent machines, a Standard Installation can be used from the Installation Type page, which will cause the Server Administrator not to be installed. When a client data source is created on that machine, it will be able to connect to the already existing server data source.
Parent topic: Configuring Relativity Data Sources


Relativity Drivers

Driver is a term that ODBC uses to describe the software that connects an ODBC-enabled application to a database management system (DBMS) such as SQL Server. For Relativity, especially for the single-tier Data Manager, the driver is the entire database management system. For the client/server variant of Relativity, the Data Client is closer to what ODBC means as a driver, and the Data Server is closer to what ODBC means as a database management system.

Largely, the driver in use is not important to an ODBC-enabled application such as the Relativity Designer. The only time it becomes important is when a data source is created. At that point, the ODBC administrator will request the driver to use, and it will access the Data Source Creation routine in the driver and let it complete the process.

Thus, it is important to understand the types of Relativity drivers in order to properly understand how to answer the question of which Relativity driver to use:

Relativity (*.rcg)
This is the primary Relativity driver, and it is the name of the single-tier Relativity Data Manager. In a single-tier environment, this is the preferred driver to use with the Relativity Designer.
Relativity for ADO (.rcg)
This is also a single-tier Relativity Data Manager, but it implements a version of the ODBC API that works better with the Microsoft ADO product set, such as Excel. It is not recommended to use this driver with the Relativity Designer.
Relativity Client
This is the client-side driver for the Relativity Data Client. If the data files being accessed are on a remote (server) machine, it is recommended that a Relativity Data Server be installed on the server, and the Relativity Data Client be installed on the machine with the Relativity Designer, in which case the Relativity Client is the driver to use.
Relativity Client for ADO
This is the client-side driver for the Relativity Data Client, but it implements a version of the ODBC API that works better with the Microsoft ADO product set, such as Excel. It is not recommended to use this driver with the Relativity Designer.
Relativity Client (64-bit)
This is the client-side driver for the Relativity Data Client to use with 64-bit ODBC-enabled applications. The Relativity Designer is 32-bit ODBC-enabled and will not work with this driver.
Relativity Client for ADO (64-bit)
This is the client-side driver for the Relativity Data Client to use with 64-bit ODBC-enabled applications, but it implements a version of the ODBC API that works better with the Microsoft ADO product set. The Relativity Designer is 32-bit ODBC-enabled and will not work with this driver.
Relativity Server
This driver appears on Windows machines that have the Relativity Data Server installed. It is used to create the server-side data sources, but is not intended for direct use. Do not use a Data Source created by this driver with the Relativity Designer. Instead, use the Relativity Client driver instead.
Parent topic: Configuring Relativity Data Sources


Setting up a New Data Source

An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog.

To set up a new data source:
  1. Start the Relativity DBA.

    If you are prompted to log on to an existing database, click Cancel.

    The Relativity DBA window opens.

  2. On the File menu, click Create New Data Source.

    The Create New Data Source dialog box is displayed.

  3. Select the type of data source:
    1. Select one of File Data Source, User Data Source (only available to the current Windows account on this machine), System Data Source (available to all Windows accounts on this machine).
    2. Click Next.
  4. Select the data source driver:
    1. Select the required driver: , then click Next.
      Note: For use with Relativity DBA, we recommend the drivers.
    2. Click Finish.

    The DSN tab of the Relativity dialog box is displayed.

  5. In the Data Source Name field, enter a name for the data source.
  6. In the Description field, enter a description (optional).
  7. If the Micro Focus Relativity Data Manager (32-bit) driver was selected in step 4, in the Catalog section, do one of the following:
    • To use an existing catalog file, click Select Catalog, navigate to an .rcg file, then click Open.
    • To create a new catalog file, click Create Catalog, navigate to its required location, enter a file name, then click Open.
  8. If the Micro Focus Relativity Client driver was selected in step 4, do the following:
    1. If the Server Name field does not contain the name of the data server, click the Servers button, then click New and enter the network name of the data server machine.
    2. In the Server Name field, select the name of the machine on which the data server is running.
    3. In the Server DSN field, select the name of the server data source.
  9. Click OK.
    Note: These options are the minimum required to create the data source; for a more comprehensive explanation of all the options on this dialog box, refer to the Relativity Data Manager Help file.

    The Open Existing Data Source dialog box is displayed. If necessary, locate the name of the new data source and select it.

  10. Click Connect.
    • If this is a new catalog, it is now open.
    • If this is an existing catalog, and security has been defined, the Database Logon dialog box is displayed. Enter valid logon credentials, then click Login to open the catalog.
Parent topic: Configuring Relativity Data Sources


Opening an Existing Data Source

Note: You cannot open a data source if another user has it open in either Relativity Designer or Relativity DBA.
  1. Start the Relativity DBA.

    The Relativity DBA window opens.

    Note: When you start Relativity DBA, you are prompted to open the last opened data source. If you choose to open that data source, you do not need to follow the further instructions; if you do not choose to open the last data source, click Cancel and continue.
  2. On the File menu, select one of the following:
    • Connect to <data source last opened> - use this option to open the same data source as was opened in your last session.
    • Connect to Existing Data Source - use this option to open a data source that has already been configured.

      The Open Existing Data Source dialog box is displayed. (If you selected Connect to <data source last opened>, skip the next step.)

    Shortcut: Click the data source to the right of Recent DSN, select the required data source, then click Connect.
  3. On the Open Existing Data Source dialog box, click the data source currently shown, select the data source to open, and then click Connect.

    If the catalog associated with this data source has no security (that is, no group owner), the catalog is opened immediately; if this is the case, you are advised to add some privileges to the catalog - see Catalog Ownership and procedures on how to define catalog ownership.

    If the catalog has a group owner, the Database Logon dialog box is displayed.

  4. Complete the fields in the Database Logon dialog box, then click Connect:
    • UserId - the name of the owning group or the name of a user in the owner group.
    • Password - the group/user may not have a password set; if not, leave this field blank.

    The data source is opened, and you are connected to the catalog.

Parent topic: Configuring Relativity Data Sources


Closing a Data Source

To close a data source, do one of the following:

  • On the File menu, click Close Current Data Source.

  • To the right of the Current DSN box, click Close.

When you close a data source, the Relativity DBA window remains open, allowing you to reopen the data source, open another data source, set up a new data source, or exit the Relativity DBA.

Parent topic: Configuring Relativity Data Sources


Configuring the Workspace

By default, the Relativity DBA window has four discrete areas, as shown in Relativity DBA Window. You can configure certain elements of this to suit your needs.

The Catalog Explorer, Properties pane, and the Status pane can all be undocked, and then moved to different locations within the window. Within the Work area, you can also perform similar docking and resizing of tabs, within the confines of the Work area; this is useful if you want to display two FDs side by side, for comparison.

You can also alter the appearance of the Relativity DBA window by applying a theme.

  • Relativity DBA Window
  • Setting a Theme for the Relativity DBA Window
Parent topic: Getting Started


Relativity DBA Window

The Relativity DBA window has four discrete areas:

1. The Catalog Explorer
This is the main navigational tool to allow you to move between most areas of the catalog.
All main objects within the catalog are displayed in two main sections:
  • Table Definitions - Displays the table definitions within the catalog as an alphabetical list. From this section you can also create new table instances. It is also where you can create the COBOL data files for the table instances.
  • User Groups and Users - The list of current groups and their users. From this section you can create new groups and users, and edit or delete existing ones.

2. Work area

This is the main area where you view the contents of the tables. It is a tabbed area that allows you to open many tables, and settings dialogs (from the Tools menu) at once, so you can work on things concurrently.

3. Properties pane

This pane displays detailed information on elements of the catalog, such as the table definitions.

4. Status pane

The Status pane displays an audit trail of system responses to your catalog operations. Click each of the tabs (Errors, Warnings, Info, and Time) to toggle that particular information on and off. You can also save off the current information to a text file, or clear the messages down.

Another salient section of the screen is the Current DSN indicator. Not only does it show which data source you are currently logged on to, but it also enables you to quickly connect to other data sources.

Parent topic: Configuring the Workspace
Related reference
Setting a Theme for the Relativity DBA Window


Setting a Theme for the Relativity DBA Window

  1. On the Tools menu, point to Theme and select one of the available themes.

    The theme is applied to the Relativity DBA window.

Parent topic: Configuring the Workspace
Related reference
Relativity DBA Window


Setting Options

Relativity allows you to specify default settings for various configuration preferences, including data sources, date formats, and COBOL types.

To display the Options pane:

  1. On the Tools menu, click Options.
  2. In the Options pane, click one of the option tabs to display the corresponding preferences:
  • General Options
    The General tab contains options that enable the user to specify general behavior and contents of Relativity DBA.
Parent topic: Getting Started


General Options

The General tab contains options that enable the user to specify general behavior and contents of Relativity DBA.

The following table describes the options available on the General tab.

Option | Description
Open Last Data Source on Startup | When this tick-box is selected, Relativity DBA remembers the last data source that was open, and attempts to open it again the next time it starts.
Show Start Page on Startup | When this tick-box is selected, the Start Page tab is open when you first open a data source.
Default maximum rows returned in Show Data | Set the maximum number of rows that are returned when you preview table data. You can adjust this temporarily when previewing the data.
Automatically grant 'SELECT' access in granting other table/column privileges | When this tick-box is selected, 'SELECT' access is automatically granted when granting other table/column privileges. When this tick-box is not selected, 'SELECT' access must be granted manually each time.
Save layout | Relativity DBA remembers certain screen sizings and positions.
Transform reports exported to XML | When this tick-box is selected, the specified .xslt file, located in the reports directory, is used to transform reports exported to XML format. (The default ReportToHtml.xslt file is supplied with Relativity DBA.)
Parent topic: Setting Options


Creating Table Instances

The ability to create table instances in Relativity DBA is controlled by the privileges assigned to the group that the current user belongs to.

If you are an administrator of a catalog, and you have Create Table privileges on one of its table definitions, you can use Relativity DBA to create a new table instance based on that table definition. When creating the new instance, you can select any COBOL data file for which the table definition has been designed, and then immediately preview that data with the table definition applied.

Administrators with this privilege can also delete table instances from the catalog, even those created at design-time in the Relativity Designer.

  • Creating a Table Instance
  • Using the Query Builder
  • Configuring Tables for Multi-File Support
  • Deleting a Table Instance
Parent topic: Micro Focus Relativity DBA for Windows


Creating a Table Instance

Use the following instructions to create the table instance, and then preview and manipulate its data.

  1. In the Catalog Explorer, double-click the Table Definitions node.

    The catalog's table definitions are displayed.

  2. Right-click the relevant table definition and select New Table Instance.
    Note: If you do not have privileges to create a table instance for that definition, the option is not displayed. You must get the catalog owner or another administrator with grant privileges on that table definition to grant the Create privilege.

    The Create Table Instance for <table-def> dialog box is displayed.

  3. In the Table Name field, type a unique name for the table instance. (The field background remains red until the name is unique.)
  4. In the File Path field, enter the full path and file name to the (first) COBOL data file to be used.
  5. Click Add.

    The table instance is created.

  6. To view the data, right-click the table instance and select View Data.

    The data is displayed.

  7. Use the following tools to further manipulate the display:
    • Max Rows - the maximum number of rows shown in the table preview. (You can set this default in the Tools > Options > General menu.)
    • Max Errors - the maximum number of errors encountered before the preview stops showing more rows (up to the Max Rows value).
    • Filter on Column - show only records that contain a specific value in a particular column: select the column in the drop list, then in the Filter string field type the string on which to filter.
    • Query Builder - a GUI tool used to define SQL queries for the preview; see Using the Query Builder for more information.
  8. To exit the preview, click [image] on the <table-name> data tab.
Parent topic: Creating Table Instances
Related reference
Using the Query Builder
Configuring Tables for Multi-File Support
Deleting a Table Instance


Using the Query Builder

The Query Builder is available when you are viewing the table data.

The Query Builder allows you to design a simple query to retrieve data from specific columns of a table instance. The ability to define a query on a selected table is highly useful; for example, you can easily find erroneous data in your table by using the sort and specific criteria options to exclude data that you do not want to see.

Use the selection table at the top of the pane to select the columns to include, and the sort method and criteria of those columns, and then click Execute Query to run the underlying SQL on the table.

You can further narrow down the results by limiting the amount of rows displayed (Max Rows), or stop displaying results if a certain number of data errors are retrieved (Max Errors).

Specifying criteria

When building an entry in the Criteria row of the Query Builder form, you can use any expression that evaluates to a single value, True or False. An expression is any combination of operators, literal values, and names of columns.

The most commonly used conditions for numeric and date columns are the comparison operators, as defined below:

Operators | Definition
> | Greater than
> | Less than
= | Equal to
>= | Greater than or equal to
<= | Less than or equal to
<> | Not equal to
Between | Numeric range
Parent topic: Creating Table Instances
Related reference
Creating a Table Instance
Configuring Tables for Multi-File Support
Deleting a Table Instance


Configuring Tables for Multi-File Support

To configure tables that use more than one data file, multi-file support for the file definition must have been enabled in the Relativity Designer. The following instructions assume that this has already been done, and that the table instance requiring multiple files has already been created.

You will now add all required files to the table instance and label each one of them.

  1. In the Catalog Explorer, double-click the Table Definitions node.

    The table definitions are displayed.

  2. Expand the table definition containing the multi-file table instance, then expand the table instance.
  3. If the table instance already contains a data file, label the initial data file:
    1. Right-click the data file and select Edit File.

      The Edit File dialog box is displayed.

    2. In the Label for this source field, type a name by which this file will be identified, then click Apply.

  4. Add and label further data files:
    1. Right-click the table instance, then select Add File Source.

      The Add Additional File Source dialog box is displayed.

    2. In the File Path field, enter the path and file name of the next data file.
    3. In the Label for this File field, type a name by which this file will be identified, then click Add.

    4. Repeat these steps to add further files.

    The changes are saved to the catalog immediately.

    As long as the column representing the file label is defined in the table definition, data from each of the files is identified with the labels just entered.

Parent topic: Creating Table Instances
Related reference
Creating a Table Instance
Using the Query Builder
Deleting a Table Instance


Deleting a Table Instance

  1. In the Catalog Explorer, double-click the Table Definitions node.

    The catalog's table definitions are displayed.

  2. Right-click the relevant table definition and select Delete Table Instance.
    Note: If you do not have privileges to create a table instance for that definition, you are also unable to delete one, and the option is not displayed. You must get the catalog owner or another administrator with grant privileges on that table definition to grant the Create privilege.
  3. Click Yes to confirm deletion.

    The table instance is deleted

Parent topic: Creating Table Instances
Related reference
Creating a Table Instance
Using the Query Builder
Configuring Tables for Multi-File Support


Maintaining the Relativity Database

Use the following within the Relativity DBA to maintain a Relativity database:

  • Defining Date Constants
    Relativity provides a number of options that interpret the way in which COBOL dates are translated to SQL dates. These options, collectively known as date constants, are stored in the Relativity catalog.
  • Maintaining Character Sets
    Maintain a list of character sets that Relativity is able to recognize.
  • Define Nonstandard Character Sets
    Map nonstandard character sets to ones Relativity is familiar with in order to show data that originated from a source that Relativity is unable to recognize.
  • Distributing Catalogs
    If you are going to distribute a Relativity catalog to end-users, there are a number of conditions that you must comply with.
  • Distributing Updated Catalogs
    If you distribute catalogs to end-users, there will be occasions when you need to send out updates to that catalog.
Parent topic: Micro Focus Relativity DBA for Windows


Defining Date Constants

Relativity provides a number of options that interpret the way in which COBOL dates are translated to SQL dates. These options, collectively known as date constants, are stored in the Relativity catalog.

Date constants control the conversion in certain transforms and internal functions of COBOL data item values to SQL column date values.

The date constants can be adjusted using the Relativity Designer or the Relativity DBA to reflect common algorithms used in COBOL procedural code.

The values and structures of the date constants can be changed by appropriate actions in the Date Constants dialog box:

  • Define Base Date for Days Count
    The Base Date for Days Count constant specifies the date used to interpret date values that are represented as an integer number of days from a base date in the Gregorian calendar.
  • Define the Structure and Base Year for YY Dates
    The 'YY' Dates Date Structure constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed, and the 'YY' Base Year constant specifies the base year used to interpret date values containing a two-digit year.
  • Define the Structure and Base Date for YYYY Dates
    The 'YYYY' Dates Date Structure specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed, and the 'YYYY' Base Year constant specifies the base year used to interpret date values containing a four-digit year.
Parent topic: Maintaining the Relativity Database


Define Base Date for Days Count

The Base Date for Days Count constant specifies the date used to interpret date values that are represented as an integer number of days from a base date in the Gregorian calendar.

The default base date is December 30, 1899, and so an integer value of zero in the COBOL data item thus represents this date, and an integer value of two in the COBOL data item represents the date January 1, 1900. Negative values are allowed in a signed COBOL data item to represent dates prior to the specified base date.

  1. On the Tools menu, click Date Constants.

    The Date Constants tab is displayed.

  2. In the Base Date for Days Count section, click [image] and use the calendar to select a date.
  3. Click Save to save the changes to the catalog.
    Tip: If you click Defaults, the base date reverts back to December 30, 1899.
Parent topic: Defining Date Constants
Related concepts
Define the Structure and Base Year for YY Dates
Define the Structure and Base Date for YYYY Dates


Define the Structure and Base Year for YY Dates

The 'YY' Dates Date Structure constant specifies the structure to be used for COBOL data items that were associated with a six-digit date transform when the catalog was designed, and the 'YY' Base Year constant specifies the base year used to interpret date values containing a two-digit year.

The six-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with two-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYMMDD (a two-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

The default base year is 1900, and is added to a two-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a two-digit year.

Additionally, if you have six-digit dates that span centuries, use the Use 'YY' Century Cutoff constant to specify the century cutoff year, which is used to interpret date values containing a two-digit year that are considered to be in the next century if lower than the specified cutoff.

The default value is 1900. Using the default, all two-digit years are considered to be in the twentieth century (nineteen hundreds). If the value of 'YY' Century Cutoff is greater than 1900, then the value of 'YY' Base Year must be equal to 1900. The value of 'YY' Century Cutoff is only used when it is greater than 1900.

  1. On the Tools menu, click Date Constants.

    The Date Constants tab is displayed.

  2. In the 'YY' Dates section, in the Date Structure field, select one of the available structures:
    • YYMMDD
    • MMDDYY
    • DDMMYY
  3. Select Use 'YY' Base Year, and in the Base Year field, enter a value (up to four digits) for the base year.
  4. If you have six-digit dates that span centuries, select Use 'YY' Century Cutoff, and in the Century Cutoff field, enter a value (up to four digits) for the cutoff.

    For example, setting this constant to 1930 would cause any two-digit years between 0-29 to be interpreted to be in the next century (for example, 2029).

  5. Click Save to save the changes to the catalog.
    Tip: If you click Defaults, the structure reverts to YYMMDD, the base year reverts to 1900.
Parent topic: Defining Date Constants
Related concepts
Define Base Date for Days Count
Define the Structure and Base Date for YYYY Dates


Define the Structure and Base Date for YYYY Dates

The 'YYYY' Dates Date Structure specifies the structure to be used for COBOL data items that were associated with an eight-digit date transform when the catalog was designed, and the 'YYYY' Base Year constant specifies the base year used to interpret date values containing a four-digit year.

The eight-digit date transform is specified during catalog design when the structure of end-user COBOL dates, with four-digit years, varies for different end-user sites. Each end-user site can set this variable to the structure used in its files. The default structure is YYYYMMDD (a four-digit year, followed by a two-digit month of the year, followed by a two-digit day of the month).

The default base year is 0. The base year is added to a four-digit year value obtained from a COBOL data item when computing a column date value and is subtracted from the column date year value when computing a COBOL data item that contains a four-digit year.

  1. On the Tools menu, click Date Constants.

    The Date Constants tab is displayed.

  2. In the YYYY Dates section, in the Date Structure field, select one of the available structures:
    • YYYYMMDD
    • MMDDYYYY
    • DDMMYYYY
  3. In the 'YYYY' Base Year field, enter a value (up to four digits) for the base year.
  4. Click Save to save the changes to the catalog.
    Tip: If you click Defaults, the structure reverts to YYYYMMDD, and the base year reverts to zero.
Parent topic: Defining Date Constants
Related concepts
Define Base Date for Days Count
Define the Structure and Base Year for YY Dates


Maintaining Character Sets

Character sets provide a means of associating language characters with an 8-bit number to represent those characters in a data file. It is possible that the character set used to represent the data within a COBOL data file is different from the character set used by the ODBC application receiving the data.

The Character Set Maintenance dialog box provides Relativity with a mechanism for translating between the two character sets. However, Relativity must know the character set that is being used within the data file to represent the characters. This character set is initially determined when the FD is imported by setting the Character Set field, shown when Show Advanced Import Options is selected during a COBOL FD import. The character set may then be modified after import.

For more information and procedures on how to maintain character sets, choose from one of the following topics:

  • Adding a Standard Character Set
  • Adding a Non-standard Character Set
  • Changing Existing Character Sets for a Data Source
  • Changing the Location of the Euro Character in a Character Set
Parent topic: Maintaining the Relativity Database


Adding a Standard Character Set

Relativity supports a large number of standard character sets. Before one of these standard character sets can be used, it must be added to the data source.

  1. From the Tools menu, click Character Sets.

    The Character Sets tab opens, displaying a list of character sets already in the catalog.

  2. Click Add a character set.

    The Add a Character Set to Catalog section is displayed.

  3. Click the box to the right of From standard character set, select one of the standard character sets, then click Add.

    It is added to the list of character sets already in the catalog.

  4. Click Save.

    The changes are saved.

  5. Close the Character Sets tab.
Parent topic: Maintaining Character Sets
Related concepts
Adding a Non-standard Character Set
Changing Existing Character Sets for a Data Source
Changing the Location of the Euro Character in a Character Set


Adding a Non-standard Character Set

Occasionally, the data stored in a file does not match any of the supported character sets. In such cases, a nonstandard character set must be defined and imported into the Relativity data source before it can be used. To define a nonstandard character set, see Define Nonstandard Character Sets.

  1. From the Tools menu, click Character Sets.

    The Character Sets tab opens, displaying a list of character sets already in the catalog.

  2. Click Add a character set.

    The Add a Character Set to Catalog section is displayed.

  3. Click [image] to the right of From CS File, then use the Open dialog box to select a .cs file that contains the nonstandard character set.
  4. Click Add.

    To see a list of errors that can occur when a character set is imported into a Relativity data source, see Error Messages when Importing a Character Set.

    The new character set is added to the list of character sets already in the catalog.

  5. Click Save.

    The changes are saved.

  6. Close the Character Sets tab.
Parent topic: Maintaining Character Sets
Related concepts
Adding a Standard Character Set
Changing Existing Character Sets for a Data Source
Changing the Location of the Euro Character in a Character Set


Changing Existing Character Sets for a Data Source

If the actual character set that describes the characters in a data source's files is different from the character set Relativity has recorded, the Character Set Maintenance dialog box can be used to change it.

  1. From the Tools menu, click Character Sets.

    The Character Sets tab opens, displaying a list of character sets already in the catalog.

  2. Click Modify FD character sets.

    The Modify FD character sets section is displayed.

  3. In the list of current character sets, select the character set to change from.

    A list of files currently using that character set are listed.

  4. In the list of current character sets, select the character set to change to.

    By default, in the File Definition list, all files are selected to replace the old character set with the new one.

  5. In the Native and Source columns, clear the selections that you do not want to change, then click Replace.
  6. Click Save.

    The changes are saved.

  7. Close the Character Sets tab.
    Note: To show the updated details in the Catalog Explorer, you may need to click [image] (Refresh).

Shortcut:

To quickly change the character set of a particular FD file, select the required entry in the Catalog Explorer, then update the Source Character Set and Native Character Set properties in the Properties pane.

Parent topic: Maintaining Character Sets
Related concepts
Adding a Standard Character Set
Adding a Non-standard Character Set
Changing the Location of the Euro Character in a Character Set


Changing the Location of the Euro Character in a Character Set

Some COBOL applications supported the Euro character before the International Standard Organization decided its value in standard character sets. In these instances, Relativity needs to modify its understanding of the value of the character in the standard character set.

  1. From the Tools menu, click Character Sets.

    The Character Sets tab opens, displaying a list of character sets already in the catalog.

  2. In the list of current character sets, select the required character set.
  3. Click the field in the Euro column, then enter a numerical value (between 0 and 255) that will correspond to the Euro character.
  4. Click Save.

    The changes are saved.

  5. Close the Character Sets tab.
Parent topic: Maintaining Character Sets
Related concepts
Adding a Standard Character Set
Adding a Non-standard Character Set
Changing Existing Character Sets for a Data Source


Define Nonstandard Character Sets

Relativity supports many standard character sets. If you need to define a character set that is nonstandard, however, Relativity has the ability to map data stored in one character set to a different character set for display purposes. This is usually necessary when data that was initially stored using one character set standard must be displayed using another character set standard; for example, data stored on a UNIX server using an ISO 8859 standard character set that must be displayed on Windows using a Code Page standard character set. ISO 8859 and Code Page character set standards are similar, but not identical, in the 8-bit values that are used to represent the different display characters. When the standards disagree on the 8-bit values (known as Code Points), the actual character displayed (known as a Glyph) will be incorrect.

To describe a character set, Relativity uses a derivation of the Unicode Consortium's Format A character set definitions.

When the mapping tables are created between two character sets, unused Code Points and Code Points with unmatched Glyphs have a simple, one-to-one mapping between the two character sets. This mapping proceeds from the lowest Code Point to the highest and is symmetrical. That is, a character that is read and mapped through these mapping tables will have the correct value stored on a subsequent UPDATE operation.

If the data within a file does not match any of the character sets already defined in Relativity, then the character set of the data file must be installed in the Relativity data source. By so doing, Relativity can build the mapping tables later.

  • Unicode Consortium's Format A
  • Supported Standard Character Sets
  • Defining a Nonstandard Character Set
  • Modifying an Existing Relativity Character Set
  • Importing a Standard Character Set Not Supported by Relativity
  • Error Messages When Importing a Character Set
Parent topic: Maintaining the Relativity Database


Unicode Consortium's Format A

Standard character sets in the Unicode Consortium's Format A are available from ftp://ftp.unicode.org/Public/MAPPINGS. To locate the character set you need, use one of the following methods:

  • If the character set is a standard Microsoft Windows Code Page, change to the directory, VENDORS/MICSFT/WINDOWS.
  • If the character set is an ISO 8859 character set, change to the directory, ISO8859.
  • If the character set is none of the above, explore the other directories in ftp://ftp.unicode.org/Public/MAPPINGS in order to locate the desired character set.
  • If you cannot find the character set you need, you must define a nonstandard character set or modify an existing Relativity character set.

Relativity augments this format with a Charset and EndCharset clause to allow more than one character set to appear in the character set source file.

A character set source file is a simple text file with the extension of .cs. Comments may appear anywhere in the file and are introduced with the hash character (#) and extend to the end of the line. Numeric values may begin with '0x' to indicate a hexadecimal constant, a '0' only to indicate an octal constant, or '1' through '9' to indicate a decimal constant. Strings are delimited by quotes ("").

One or more character sets may be in this file. The format of each character set is:

Charset "Character Set Name" character-set-number
code-point-value unicode-value
code-point-value unicode-value
.
.
.
EndCharset

where:

Character Set Name is a string that is the name of the character set to display in the Relativity DBA.

character-set-number is the number to assign to the character set. For character sets installed via the Relativity DBA, this value is ignored and assumed to be zero.

code-point-value is the 8-bit numeric value of the Glyph in the character set. A code-point-value that is not present in the character set is assumed to be unused.

unicode-value is the 16-bit numeric value of the Glyph in the Unicode standard. This value also may be a Unicode constant, in which case, it will be delimited by a less than symbol (<) and a greater than symbol (>). The most commonly used of these is the constant <NOT USED>, which indicates that the Code Point does not have a Glyph assigned to it.

Parent topic: Define Nonstandard Character Sets
Related concepts
Supported Standard Character Sets
Defining a Nonstandard Character Set
Modifying an Existing Relativity Character Set
Importing a Standard Character Set Not Supported by Relativity
Error Messages When Importing a Character Set


Supported Standard Character Sets

Relativity supports the following standard character sets:

Windows Latin 1 | MS-DOS Cyrillic CIS-1 | MS-DOS Hebrew
Windows Latin 2 | MS-DOS Turkish | EBCDIC US Canada
Windows Latin 5 | MS-DOS Portuguese | EBCDIC International
Windows Cyrillic | MS-DOS Icelandic | EBCDIC Greek
Windows Greek | MS-DOS French Canada | EBCDIC Latin 5 Turkish
Windows Baltic Rim | MS-DOS Greek | ISO 8859-1
Windows Hebrew | MS-DOS Greek 1 | ISO 8859-2
Windows Arabic | MS-DOS Greek 2 | ISO 8859-5
MS-DOS Latin US | MS-DOS Baltic Rim | ISO 8859-6
MS-DOS Latin 1 | MS-DOS Russian | ISO 8859-7
MS-DOS Latin 2 | MS-DOS Arabic | ISO 8859-8
MS-DOS Cyrillic | MS-DOS Arabic ASMO |
Parent topic: Define Nonstandard Character Sets
Related concepts
Unicode Consortium's Format A
Defining a Nonstandard Character Set
Modifying an Existing Relativity Character Set
Importing a Standard Character Set Not Supported by Relativity
Error Messages When Importing a Character Set


Defining a Nonstandard Character Set

  1. Using a text editor, edit a new file in which to place the character set. Name the file with the extension, .cs
  2. Insert the following line at the beginning of the file:

    Charset "Character Set Name" 0x0

    For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

  3. Insert up to 256 lines into the file, one for each character in the character set being described. On each line there must be two entries, separated by a space or a tab, with an optional third entry, also separated by a space or tab. The first entry on the line must be the 8-bit Code Point value for the entry. This corresponds to the numeric value of the character being described. The second entry is the 16-bit Unicode character for the character being defined. The third entry is an optional comment for the line, preceded by a hash (#) character.

    For example, if the character set had a Euro Sign at position 128, the line for it would be:

    128 8364 #EURO SIGN

    Or, using hexadecimal notation:

    0x80 0x20AC #EURO SIGN

    For Code Points where there is not a defined character, use the text <NOT USED> for the second entry.

    Note: A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.
  4. Following the lines describing the character set, insert the following line:

    EndCharset

  5. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, see Error Messages when Importing a Character Set.

Parent topic: Define Nonstandard Character Sets
Related concepts
Unicode Consortium's Format A
Supported Standard Character Sets
Modifying an Existing Relativity Character Set
Importing a Standard Character Set Not Supported by Relativity
Error Messages When Importing a Character Set


Modifying an Existing Relativity Character Set

  1. Edit the file relcs.cs in the installation directory.
  2. Locate the character set to modify.
  3. Select and copy the lines Charset and EndCharset of the desired character set and all the text in between.
  4. Create a text file in which to place the modified character set and paste in the text from Step 3.
  5. Locate the Charset line and change the text between the quotes to the name for the character set that is to be visible from within the Select Character Set dialog box. Change the number at the end of the line to 0x0.
  6. Locate the lines for the Code Points to be changed in the character set. This can be done by examining first entry on each the line. This value is the numeric value for the character in the character set. For example, in most Latin-based character sets, the capital letter A has the Code Point value of 65 (or 0x41 hexadecimal).
  7. Change the second entry on the line to the Unicode value for the new character to be at this Code Point. For example, if you want the character at Code Point 65 to be interpreted as a capital letter A with an Acute, change the line to the following:

    0x41 0x00C1 #LATIN CAPITAL LETTER A WITH ACUTE

  8. If necessary, insert a new line with the Code Point and Unicode entries for new Code Points.
    Note: A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.
  9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, see Error Messages when Importing a Character Set.

Parent topic: Define Nonstandard Character Sets
Related concepts
Unicode Consortium's Format A
Supported Standard Character Sets
Defining a Nonstandard Character Set
Importing a Standard Character Set Not Supported by Relativity
Error Messages When Importing a Character Set


Importing a Standard Character Set Not Supported by Relativity

  1. FTP to the site ftp.unicode.org.
  2. Change to the directory Public/MAPPINGS .
  3. Locate the character set you want, as follows:
    • If the character set is a standard Microsoft Windows Code Page, change to the directory, VENDORS/MICSFT/WINDOWS
    • If the character set is a standard Microsoft DOS Code Page, change to the directory, VENDORS/MICSFT/PC
    • If the character set is an ISO 8859 character set, change to the directory, ISO8859.
    • If the character set is none of the above, explore the other directories in ftp.unicode.org/Public/MAPPINGS in order to locate the desired character set.
    • If you cannot find the character set you want, you must define a nonstandard character set or modify an existing Relativity character set.
  4. Locate the file for the desired character set and download the file to your local machine. Name it with the extension .cs.
  5. Edit the file with a text editor, taking care to delete any control characters, usually marked with the characters ^D, from the file.
  6. Insert the following line at the beginning of the file:

    Charset "Character Set Name" 0x0

    For Character Set Name, substitute the name for the character set that is to be visible from within the Select Character Set dialog box.

  7. At the end of the file, insert the following line:

    EndCharset

  8. Examine the remaining lines for any that are missing the second entry on the line. This second entry is the 16-bit Unicode character for the character being defined. In the definitions available on ftp.unicode.org, unused Code Points are left blank with the comment of UNDEFINED. Insert <NOT USED> as the second entry on the line.
    Note: A Unicode character may be used only once in a character set. If it appears twice, an error indicating a duplicate Unicode character will be generated during import. Unique Unicode characters are necessary for all defined Code Points in order to generate mapping tables that can be used to translate characters both to and from the new character set. Rather than arbitrarily assigning Unicode characters to unused Code Points, either leave them out of the character set definition, or use <NOT USED> as the Unicode character entry. When Relativity encounters the <NOT USED> entry, it creates an association in the character set being defined with unused or unmatched entries in the target character set. In this manner, if an undefined character is present in the data, it will be translated consistently.
  9. Save the file and import it into the Relativity data source.

To see a list of errors that can occur when a character set is imported into a Relativity data source, see Error Messages when Importing a Character Set.

Parent topic: Define Nonstandard Character Sets
Related concepts
Unicode Consortium's Format A
Supported Standard Character Sets
Defining a Nonstandard Character Set
Modifying an Existing Relativity Character Set
Error Messages When Importing a Character Set


Error Messages When Importing a Character Set

The following errors may be produced when importing a nonstandard character set into a Relativity data source:

Redefinition of Character
Indicates that the value used in the code-point-value has appeared previously in the character set definition. A common cause of this problem is the omission of a unicode-value or code-point-value, causing the charset compiler to misinterpret the value. The code-point-value and unicode-value must appear in pairs.
Syntax Error
Indicates that the character set does not conform to the format of a character set definition. This usually indicates that a numeric constant was not detected where it was expected.
Unicode constant too large
Indicates that a unicode-value was larger than can be stored in 16-bits.
Code Point constant too large
Indicates that a code-point-value was larger than can be stored in 8-bits. This message may indicate a missing value from a code-point-value and unicode-value pair.
Illegal constant
Indicates that a decimal constant contained a nonnumeric character.
Illegal hex constant
Indicates that a hexadecimal constant contained a non-hex character.
Illegal octal constant
Indicates that an octal constant contained a non-octal character.
Illegal string constant
Indicates that a string constant did not terminate before the end of a line.
Unknown unicode constant
Indicates that a Unicode constant is unrecognized.
Unknown keyword
Indicates that either the keyword Charset or EndCharset was not located where expected.
Keyword too long
Indicates that a keyword was expected in the character set source file, but it was too large to be processed.
String constant too long
Indicates that a string constant was too large to be processed.
Illegal Unicode constant
Indicates that a Unicode constant did not have a closing delimiter (>) before the end of a line.
Unicode constant too long
Indicates that a Unicode constant was too long to be processed.
In Character Set Name, Unicode unicode-value duplicated at positions code-point-value and code-point-value
Indicates that the character set with the name Character Set Name has the same Unicode character in multiple Code Point locations. In order to create symmetrical mapping tables, a Unicode character may be used only once per character set.
Parent topic: Define Nonstandard Character Sets
Related concepts
Unicode Consortium's Format A
Supported Standard Character Sets
Defining a Nonstandard Character Set
Modifying an Existing Relativity Character Set
Importing a Standard Character Set Not Supported by Relativity


Distributing Catalogs

If you are going to distribute a Relativity catalog to end-users, you will need to comply with a number of conditions. (Instructions for performing each of these tasks can be found in the appropriate Relativity Client/Server Installation Guide.)

  • For client/server installations, the data server must be installed at the end-user site, on the same machine as the user data. The data client software must be installed on the individual machines with the ODBC applications.
  • For single-tier installations, the data manager must be installed on the same machine as the end-user data and the ODBC applications. If the user-data resides on a file server, it is possible to access it with data manager installed on multiple machines, but the Relativity DBMS must be installed on every Windows system that is to access the catalog. It is highly desirable for the catalog to reside on the file server with the user-data.
  • The catalog must be delivered on appropriate media for the end-user.
  • You may also choose to install the Relativity DBA on selected Windows machines, which will allow end-users to maintain security of the catalog.
  • For client/server installations, a server data source must be created that associates the data source name with the catalog.
  • For each Windows system that is to access the catalog, an ODBC data source must be created. For client/server installations, a client data source must be created that associates the data source name with the server data source. For single-tier installations, a single-tier data source must be created that associates the data source name with the catalog.
Parent topic: Maintaining the Relativity Database


Distributing Updated Catalogs

If you distribute catalogs to end-users, there will be occasions when you need to send out updates to that catalog.

There are multiple ways to accomplish this:

  • If you do not distribute the Relativity DBA, the end-user cannot modify your catalog; therefore, you just send an updated catalog and replace the end-user's existing catalog.
  • If you do allow your end-user access to the Relativity DBA, then you may wish to preserve changes made by the end-user when you distribute an updated catalog.

The Catalog Merge capability, distributed with the Relativity DBA, generally takes any changes made by the DBA and merges them into a new catalog, preserving Users, Privileges, and Connections modified and added by the end-user. For procedures on using Catalog Merge, see Merging a Catalog.

Note: Both the existing and modified catalogs must have owners in order to run this merge process.
  • Merging a Catalog
  • Rules File for Merging a Catalog
  • Sample Rules File
Parent topic: Maintaining the Relativity Database


Merging a Catalog

The updated catalog must be distributed on media appropriate for the end-user and the catalog must be in place prior to executing the catalog merge. The updated catalog either must be published to ODBC (that is, a data source created specifying it as the catalog) prior to executing the catalog merge, or the RELDBUTL.INI control file contains a CONNECT section that will create the data source prior to the merge.

The merge utility is a standalone executable that is distributed with Relativity DBA. It must be executed from a Windows command prompt, as it contains a command line parameter specifying a rules file; for example:

C:\RELDBXX\RELDBUTL.EXE C:\users\public\documents\RELDBUTL.INI
Note: C:\RELDBXX indicates the Relativity installation path.
Parent topic: Distributing Updated Catalogs
Related concepts
Rules File for Merging a Catalog
Sample Rules File


Rules File for Merging a Catalog

When distributing updated catalogs, there must be an accompanying rules file for the merge process. The rules file is an INI format file having the name RELDBUTL.INI. It can contain sections for changed file and table definition names. The minimum entries in the rules file are the names of the two data sources to merge. The format for entries is the following:

PARAMETER=value

[CATALOG] section specifies the data source names as well as the user IDs and passwords that are to be merged. The parameters are:

OLD
The customer's existing data source.
OLDUID
The customer's existing user ID.
OLDPWD
The customer's existing password.
NEW
The updated catalog's new data source.
NEWUID
The customer's new user ID.
NEWPWD
The customer's new password.

[FD] section provides a method of explaining file definition name changes. There should be an entry in this section for every FD name that has changed. The format is oldname=newname. There is no need to list unchanged file definitions; they are merged automatically.

[TABLE] section provides a method of explaining table name changes. There should be an entry in this section for every table name that has changed. The format is oldname=newname. There is no need to list unchanged table names as they are merged automatically.

[COLUMNS] section provides a method of explaining column name changes. There should be an entry in this section for every column name that has changed. The format of this section header is the keyword COLUMNS followed by a colon followed by the old name of the table. The format of the entries in the section is oldcolumn=newcolumn.

[CONNECT] section, which is optional, allows the new data source to be created as part of the merge process. The parameters are:

DESC
Can be any text that describes the data source.
CATALOG
The full access path to where the catalog will be located.
DSN
Data Source Name. This is the ODBC data source name for the new catalog.
DRIVER
The Relativity DBMS used for the new catalog.

[MESSAGES] section, which is optional, is provided to allow the Relativity Merge Utility to change the messages displayed on the screen as the merge is taking place. You may choose to provide any of these messages; you do not have to provide all. If a message is not found, the default will be used. The sample rules file (see link below) uses the defaults. The valid messages and when they are displayed are:

LOGON1
The message displayed while the Logon dialog box for the user's existing catalog is displayed.
LOGON2
The message displayed while the Logon dialog box for the new catalog is displayed. (One use for this may be to provide a new user ID and password if the DBA has changed.)
STATUS
The message displayed while the actual merge is running.
COMPLETE
The message displayed following a successful merge. (One use for this message may be to remind the user to remove any media, or to run the next step in a process.)
INCOMPLETE
The message displayed following an aborted merge process. (One use for this message may be how to proceed if errors were encountered during the merge.)
LOG
Creates a log file at the end of the merge process. The only entry in the log file is a complete or incomplete message. If you have specified COMPLETE and INCOMPLETE messages, those will be used. If not, the default for these messages will be used.

Here are the default messages that will be used if none are provided:

LOGON1
Please log on to your existing catalog.
LOGON2
Please log on to new catalog.
STATUS
This process may take some time.
COMPLETE
Relativity Merge Complete.
INCOMPLETE
Relativity Merge NOT Complete.
Parent topic: Distributing Updated Catalogs
Related concepts
Merging a Catalog
Sample Rules File


Sample Rules File

The following is an example of sample rules file:

C:\users\public\documents\RELDBUTL.INI
[CONNECT]
DESC=New Data Source
CATALOG=C:\MYDATA\MYCATALOG.RCG
DSN=MYDATA
DRIVER=Relativity for RM (*.rcg)
[CATALOG]
OLD=JMB
NEW=JMBTEST
[FD]
[TABLE]
[MESSAGES]
LOGON1=Please log on to your existing data source.
LOGON2=Please log on to new data source, user=Mike, password=Mike.
STATUS=Processing, please wait...
COMPLETE=Merge Complete. Remove media.
INCOMPLETE=Relativity Merge NOT Complete. Please call for support.
Parent topic: Distributing Updated Catalogs
Related concepts
Merging a Catalog
Rules File for Merging a Catalog


Defining Security for Relativity Databases

  • Securing Relativity Databases
    Relativity provides security that protects data in the database tables against unauthorized disclosure, alteration, or destruction.
  • Catalog Ownership
    Relativity catalogs can only be designed by a catalog owner. Furthermore, only the owner initially has the ability to create groups and users, and assign privileges to those groups.
  • Defining Groups and Users
    Define the groups and users to which you can grant privileges.
  • Defining Group Privileges
    Define privileges to groups of users to determine their access to the tables defined within a Relativity database.
Parent topic: Micro Focus Relativity DBA for Windows


Securing Relativity Databases

Relativity provides security that protects data in the database tables against unauthorized disclosure, alteration, or destruction.

For security purposes, a unit of data (or data object) ranges from an entire database to a specific column within a table of the database. A given user has different access privileges on different units of data. Access privileges (or privileges, for short) are the mechanism that provides data security for a Relativity database.

To provide data security, the person responsible for designing the databases must:

  1. Define groups and users. The first step in effective database administration is to design and establish the group structure; that is, the users and groups of users who are authorized access to the tables within the database. Groups and users are the basis for establishing such security. An individual user is identified by a user name. A group of users is identified by a group name. Each user name and group name within a Relativity database must be unique.
  2. Define catalog ownership. Catalog ownership is a role given to a particular group. Catalog owners are the only users that can log on to the database's catalog in Relativity Designer to design the relational tables, and grant access and privileges to those tables to other groups of users. Ownership is assigned to the first group defined, but it can be changed to another group, if required.
  3. Define group privileges. Catalog owners can grant specific permissions for groups, allowing other groups to access and update table data. This is similar to the GRANT/REVOKE facilities in other relational database management systems.

    In a Relativity catalog, privileges are assigned to a group of users. All users within a group inherit the privileges of the group. Not all groups associated with the Relativity database need access to all the data in the database. A group of users is given privileges only to the data that is necessary for the group to carry out its work.

    When granting privileges, it may be helpful to think of them in terms of a hierarchy, with the group that is the owner of the catalog having the highest level permissions, the group with administrator privileges having the next level of permissions, and a user group having the lowest level permission (the ability to access only one or more tables or columns).

Note: Relativity supports a set of stored procedures, identified with the prefix, DBA-, only if the user is the owner or a database administrator of the Relativity catalog. The DBA stored procedures deal with table definitions, table connections, and file names. All of the stored procedures are ODBC driver-specific. For more information, see Stored Procedures in the For Advanced Users | Relativity-Specific topic in the Relativity DBMS Help file.
Parent topic: Defining Security for Relativity Databases
Related reference
Catalog Ownership
Defining Groups and Users
Defining Group Privileges


Catalog Ownership

Relativity catalogs have an ownership property that restricts catalog design to only those users assigned to the owner group.

By default, a catalog has no owner when it is first created, which means that anyone can log on and make changes. However, as soon as the first group is added to the catalog, it automatically becomes the owner of that catalog, and only users assigned to that group can log on to the Relativity Designer and design the catalog.

You can configure Relativity Designer to check that a catalog has an owner when you log on (Tools > Options > General > Require Catalog have Owner Group), and if it does not, you are prompted to add the group that will become the owner group.

Once a catalog has an owner group, all of its users are automatically granted all privileges for the database, and can perform every operation that supports a Relativity database. They can perform such tasks as:

  • Creating groups of users for this database.
  • Granting other privileges to the group executing the Relativity Designer.
  • Granting another group the authority to grant specified privileges to other groups.
  • Revoking privileges from a group.
Parent topic: Defining Security for Relativity Databases
Related reference
Securing Relativity Databases
Defining Groups and Users
Defining Group Privileges


Defining Groups and Users

To access or configure data within a Relativity database, you need to belong to a group that has been granted privileges to perform that function or access that data. Groups and users for a Relativity database are configured using the User Groups and Users section within the Catalog Explorer pane.

There is also an additional group, the <PUBLIC> group, that is default for all catalogs. The <PUBLIC> group is only applicable to the table access privilege, but is a quick way to grant table or column access to all users of a database; see Enable Public Table Access Privileges.

For detailed information on defining groups and users, choose from the following topics:

  • Add a User Group to the Catalog
  • Add a User to a Group
  • Delete a Group from the Catalog
  • Delete a User from a Group
  • Change a Group Name and Password
  • Change a User Name and Password
Parent topic: Defining Security for Relativity Databases
Related reference
Securing Relativity Databases
Catalog Ownership
Defining Group Privileges
Enable Public Table Access Privileges


Add a User Group to the Catalog

If this is the first group to be added, it is automatically set as the owner group of the catalog and has all privileges granted automatically; you can only set group privileges on subsequent groups added.

  1. In the Catalog Explorer pane, right-click the User Groups and Users node, then click New Group.

    The Add New Group dialog box is displayed.

  2. In the Group Name field, type the name of the group to be added to the catalog.
  3. In the Password field, type a password for the group. An asterisk (*) character is displayed for each character entered. This field is optional.
  4. If you entered a password, in the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.
  5. (Optional) Select the Expires On tick-box, then click [image] and use the calendar to enter an expiry date.

    Access to any of the catalog's tables, for any user within this group, will be refused after the stated expiry date.

  6. Click Add to add the new group.

    The new group is now displayed in the User Groups and Users node. You can now add one or more users to the group.

Parent topic: Defining Groups and Users
Related information
Add a User to a Group
Delete a Group from the Catalog
Delete a User from a Group
Change a Group Name and Password
Change a User Name and Password


Add a User to a Group

  1. In the Catalog Explorer pane, double-click the User Groups and Users node.
  2. Right-click the required group, and select New User.

    The Add User to <group> dialog box is displayed.

  3. In the New User Name field, type the name of the user to be added to the selected group.
  4. In the Password field, type a password for the user. An asterisk (*) character is displayed for each character entered. This field is optional.
  5. If you entered a password, in the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.
  6. (Optional) Select the Expires On tick-box, then click [image] and use the calendar to enter an expiry date for the user.

    Access to any of the catalog's tables will be refused for this user after the stated expiry date.

  7. Click Add to add the new user to the group.

    The new user is now displayed in the User Groups and Users node, underneath the appropriate group.

Parent topic: Defining Groups and Users
Related information
Add a User Group to the Catalog
Delete a Group from the Catalog
Delete a User from a Group
Change a Group Name and Password
Change a User Name and Password


Delete a Group from the Catalog

Note: You cannot delete the Owner group.
  1. In the Catalog Explorer pane, double-click the User Groups and Users node.
  2. Right-click the required group, and select Delete Group.

    A confirmation box is displayed. If users still exist in the group, they will also be deleted.

  3. Click Yes to confirm.

    The group is deleted.

Parent topic: Defining Groups and Users
Related information
Add a User Group to the Catalog
Add a User to a Group
Delete a User from a Group
Change a Group Name and Password
Change a User Name and Password


Delete a User from a Group

  1. In the Catalog Explorer pane, double-click the User Groups and Users node.
  2. Expand the group that the user belongs to, and then select the user entry.
  3. Right-click the required user, and select Delete.

    A confirmation box is displayed.

  4. Click Yes to confirm.

    The user is deleted from the group.

Parent topic: Defining Groups and Users
Related information
Add a User Group to the Catalog
Add a User to a Group
Delete a Group from the Catalog
Change a Group Name and Password
Change a User Name and Password


Change a Group Name and Password

  1. In the Catalog Explorer pane, double-click the User Groups and Users node.
  2. Right-click the required group, and select Rename Group.

    The Rename Group dialog box is displayed.

  3. In the Group Name field, edit the current name.
  4. In the Password field, type a password for the group. An asterisk (*) character is displayed for each character entered. This field is optional.
  5. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.
  6. Click Save.

    The password is updated.

Tip: To remove a password from the group, click Save without entering a new password in either the Password or Verify Password fields.
Parent topic: Defining Groups and Users
Related information
Add a User Group to the Catalog
Add a User to a Group
Delete a Group from the Catalog
Delete a User from a Group
Change a User Name and Password


Change a User Name and Password

  1. In the Catalog Explorer pane, double-click the User Groups and Users node.
  2. Expand the required group to display the users.
  3. Right-click the user, and select Rename User.

    The Rename User dialog box is displayed.

  4. In the User Name field, edit the current name.
  5. In the Password field, type a password for the group. An asterisk (*) character is displayed for each character entered. This field is optional.
  6. In the Verify Password box, type the password for a second time. An asterisk (*) character is displayed for each character entered.
  7. Click Save.

    The password is updated.

Tip: To remove a password from the user, click Save without entering a new password in either the Password or Verify Password fields.
Parent topic: Defining Groups and Users
Related information
Add a User Group to the Catalog
Add a User to a Group
Delete a Group from the Catalog
Delete a User from a Group
Change a Group Name and Password


Defining Group Privileges

Groups are assigned privileges to a Relativity database with the appropriate actions on the Privileges tab. The granting of a privilege to a group of users provides a mechanism to protect data in a database. Instead of having access to all the data in a database, a granted privilege restricts the user's access only to the data needed to carry out the user's work.

Privileges are assigned by the catalog owner, to other groups; therefore, you must add at least one additional group (that is not the catalog owner) to be able to set privileges.

There is also an additional group, the <PUBLIC> group that is only applicable to the table access privilege, but is a quick way to grant table or column access to all users of a database; see Enable Public Table Access Privileges.

When assigning privileges, there are three choices for each pairing of a group and a privilege, table, or column:

  • Granted. The group has the selected privilege, but cannot grant it to other groups.
  • With Grant. The group has the selected privilege and can grant that privilege to other groups.
  • Not Granted. The group does not have the selected privilege. This is implied by the absence of a selection.

To access a group's privileges, in the Catalog Explorer, expand User Groups and Users, and then double-click the required group. Note, you cannot access or edit the privileges for the Owner group as that group automatically has maximum privileges assigned.

The group's privileges appear in the middle pane, and the group's properties are displayed in the right-hand pane.

For detailed information on enabling privileges, choose from the following topics:

  • Administrator Privileges
  • Create Users Privilege
  • Create Tables Privilege
  • Table Access Privileges
  • Column Access Privileges
  • Enable Public Table Access Privileges
Parent topic: Defining Security for Relativity Databases
Related reference
Securing Relativity Databases
Catalog Ownership
Defining Groups and Users


Administrator Privileges

The four Administrator privileges available for a group all pertain to database administration operations:

  • Use Administrator. Enabling the Use Administrator privilege allows the group granted the privilege to use the Relativity DBA software on the specified catalog.
  • Create Group. Enabling the Create Group privilege permits the group granted the privilege to add new database groups to the catalog.
  • Date Constants. Enabling the Date Constants privilege allows the group granted the privilege to change the existing (default) values for the date constants of the database in the catalog. These date constants include 'Days' Base Date, 'YYYY' Base Year, 'YY' Base Year, 'YY' Century Cutoff, and configurable date formats.
  • Reports. Enabling the Reports privilege permits the group granted the privilege to create and use reports for information in the catalog.
Note: The Administrator privileges cannot be assigned to the <PUBLIC> group.
  • Enable Administrator Privileges
Parent topic: Defining Group Privileges


Enable Administrator Privileges

  1. In the Catalog Explorer pane, expand the User Groups and Users node.
  2. Double-click the group for which privileges are to be assigned.

    The Privileges tab for the selected group is displayed.

  3. Select the Admin tab.

    The Use Administrator, Create Group, Reports, and Date Constants privileges are displayed. (Initially, a group has no Administrator privileges, so no privileges are selected.)

  4. Select the appropriate tick-boxes (Grant or With Grant) for each of the privileges, or leave the tick-boxes clear to not grant a privilege.
    Note: With Grant enables the group to also grant those selected privileges to other groups.
  5. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Parent topic: Administrator Privileges


Create Users Privilege

Enabling the Create Users privilege allows the group granted the privilege to add new users to a specific database group in the catalog and to delete existing users from a specific group.

Because the Create Users privilege is granted only for specific groups, it is possible to have specialized administrators of the database. For example, there could be a SalesAdmin group that is granted the privilege to create new users only for the Sales group. The director of sales would then be made a member of the SalesAdmin group so that the director could add users to or delete users from the Sales group without having to request such changes from the main administrator.

Note: The Create Users privilege cannot be assigned to the <PUBLIC> group.
  • Enable the Create Users Privilege
Parent topic: Defining Group Privileges


Enable the Create Users Privilege

  1. In the Catalog Explorer pane, expand the User Groups and Users node.
  2. Double-click any group within the node.

    The Privileges tab for the selected group is displayed.

  3. Select the Users tab.

    The database groups defined for the current catalog (except the owner group) are displayed in the Group Name column.

  4. For each group, select the appropriate tick-boxes (Create Users or With Grant) for each of the groups, or leave the tick-boxes clear so that the group is unable to create users.
    Note: Selecting these options allow the group selected in step 2 the ability to create users in the other groups in the database (shown in step 3). The With Grant option enables group members to also grant or revoke the privilege of creating users for other groups.
  5. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Parent topic: Create Users Privilege


Create Tables Privilege

Enabling the Create Tables privilege allows the group granted the privilege to add, edit, and delete table instances between the Relativity table definitions and the physical COBOL data files.

Note: The Create Tables privilege cannot be assigned to the <PUBLIC> group.
  • Enable the Create Tables Privilege
Parent topic: Defining Group Privileges


Enable the Create Tables Privilege

  1. In the Catalog Explorer pane, expand the User Groups and Users node.
  2. Double-click the group for which privileges are to be assigned.

    The Privileges tab for the selected group is displayed.

  3. Select the Tables tab.

    The table definitions for the current database are displayed:

  4. For each table, select the appropriate tick-boxes (Create Table or With Grant), or leave the tick-boxes clear so that the group is unable to create table instances.
    Note: Create Table enables members of the group selected in step 2 to add, edit, and delete table instances between the Relativity table definition and the physical COBOL data file, and With Grant enables group members to also grant or revoke the privilege for other groups.
  5. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Parent topic: Create Tables Privilege


Table Access Privileges

In a Relativity database, a given group may have access rights or privileges to a table instance in order to perform SQL operations such as SELECT, INSERT, UPDATE, or DELETE. Table privileges can apply to the whole table, or to each column of a table. If the owner wants to grant access to only specific columns of a table, then use Column privileges, but to grant table-wide privileges select one or more of the following:

  • All - enabling the All privilege allows all table privileges to the group
  • Select - enabling the Select privilege allows the group granted the privilege to access all of the columns of a specified table, including any columns added to that table later.
  • Insert - enabling the Insert privilege permits the group granted the privilege to insert into all columns of a specified table, including any columns added to that table later.
  • Update - enabling the Update privilege allows the group granted the privilege to update all columns of a specified table, including any columns added to that table later.
  • Refer - enabling the Refer privilege allows the group granted the privilege to reference all columns of a specified table in integrity constraints, including all columns added to that table later. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.
  • Delete - enabling the Delete privilege permits the group granted the privilege to delete a row from a specified table. Since deleting a row of a relational table is equivalent to deleting all columns of that row, this privilege exists only as a Table privilege; there is no corresponding Column Delete privilege.

Each table privilege also has a with Grant privilege (the w/G tick-box), which enables the group to also grant that particular privilege to other groups when using Relativity DBA.

  • Enable Table Access Privileges
Parent topic: Defining Group Privileges
Related tasks
Enable Column Access Privileges
Related reference
Column Access Privileges
Privileges Options


Enable Table Access Privileges

  1. In the Catalog Explorer pane, expand the User Groups and Users node.
  2. Double-click the group for which privileges are to be assigned.

    The Privileges tab for the selected group is displayed.

  3. Select the Tables tab.

    The table instances for the current database are displayed:

  4. For each table instance, select the appropriate tick-boxes, or leave the tick-boxes clear so that the group selected in step 2 is unable to perform the privilege on the particular table instance.
    Note: w/G (With Grant) enables group members to also grant or revoke the privilege for other groups.
  5. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Note: These options grant privileges for the entire table; to grant privileges for individual columns, click Columns and set the privileges per column.
Parent topic: Table Access Privileges


Column Access Privileges

In a Relativity database, a given group may have access rights or privileges to a column within a table. In order to perform an SQL operation, such as SELECT, INSERT, or UPDATE on a column within a table, the user must belong to a group granted the corresponding privilege for the columns affected by the operation.

The following Column privileges are available for a group:

  • Select - enabling the Select privilege permits the group granted the privilege to access specified columns of a specified table.
  • Insert - enabling the Insert privilege allows the group granted the privilege to insert into specified columns of a specified table.
  • Update - enabling the Update privilege permits the group granted the privilege to update specified columns of a specified table.
  • Refer - enabling the Refer privilege allows the group granted the privilege to reference specified columns of a specified table in integrity constraints. Integrity constraints may be specified in CREATE TABLE statements and could be used in a way that would obtain information about columns in another table for which a user would not otherwise have privileges.
Note: There is no Column Delete privilege because the SQL DELETE statement deletes a row of a table, thus requiring delete privilege on all columns. You must use the Table Delete privilege described in Table Privileges to grant the privilege to delete rows of a table.
  • Enable Column Access Privileges
Parent topic: Defining Group Privileges
Related tasks
Enable Column Access Privileges
Related reference
Table Access Privileges
Privileges Options


Enable Column Access Privileges

  1. In the Catalog Explorer pane, expand the User Groups and Users node.
  2. Double-click the group for which privileges are to be assigned.

    The Privileges tab for the selected group is displayed.

  3. Select the Tables Access tab.

    The table instances for the current database are displayed

  4. Click Columns to the right of the appropriate table instance.

    A further set of privileges is displayed, one set for each column in the table instance. If any of the privileges are already granted at the table level, Revoke (and not Grant) is displayed, and the result of selecting such a column tick-box will revoke that privilege.

  5. For each column, select the appropriate tick-boxes to grant or revoke privileges for that particular column.
  6. Click Close.
  7. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Parent topic: Column Access Privileges
Related reference
Column Access Privileges
Table Access Privileges
Privileges Options


Enable Public Table Access Privileges

  1. In the Catalog Explorer pane, right-click the User Groups and Users node, then select Public Privileges.

    The Public Privileges tab is displayed, showing only the Table Access tab.

  2. For each table instance, select the appropriate tick-boxes, or leave the tick-boxes clear so that the privilege is governed by the individual group settings.

    Instead of granting access to the whole table, you can grant access to specific columns only.

  3. Click Columns to the right of the appropriate table, and then select the required column privileges.
  4. Click Save to Catalog to save the changes; alternatively, click Revert to revert back to the last available saved privileges.
Parent topic: Defining Group Privileges


Reporting

The Relativity DBA provides a set of predefined reports to give a comprehensive overview of a catalog. These reports are run from the Designer, but groups and users that have reporting privileges are also able to run the non-data-related reports from Relativity DBA.

Each report displays in the Relativity DBA, but it can also be exported in a number of formats: XML, HTML, and CSV.

By default, reports are exported to (and most likely opened from) the default reports directory.

The following files are located in the default reports directory, and are utilized when you run a report from the same location:

ReportToHtml.xslt
If Tools > Options > General > Transform reports exported as XML is selected, this is the default XML style sheet that is used to transform your reports exported to XML format.
Report.css
This is the standard cascading style sheet used to style your reports exported to HTML format.
SortHtmlTable.js
This JavaScript file allows you to sort the table columns of your reports exported to HTML format.

If you run a report from a location other than the default reports directory, you should copy these files to the same location in order that they are used when the report is run.

Tip: You can customize the appearance of your reports by editing these files; however, we recommend that you make copies of these files before you start to edit their contents.
  • Running and Exporting Reports
  • Users Reports
  • Connections Reports
  • Privileges Reports
Parent topic: Micro Focus Relativity DBA for Windows


Running and Exporting Reports

  1. On the Reports menu, select the required report type.

    The report automatically runs, and is displayed.

  2. Click Export Report As.

    The Export Report As dialog box is displayed, and the location defaults to the reports directory.

  3. In the File name field, type the name for the report, or leave it at the default name.
  4. Click Save as type, and select the report format.
  5. Click Save.

    The report is saved to the selected location. You can now view it using an appropriate tool for the selected format. If you move the report before opening it, you should also move (a copy of) the following files to the same location, so that they are used to render the report and provide sorting ability to the report tables: ReportToHtml.xslt, Report.css, and SortHtmlTable.js.

    Tip: You can customize the appearance of your reports by editing these files; however, we recommend that you make copies of these files before you start to edit their contents.
Parent topic: Reporting
Related reference
Users Reports
Connections Reports
Privileges Reports


Users Reports

The Users report category provides detailed information about users maintained in a Relativity catalog. The Is Owner column also indicates which group is the catalog owner.

Note: The group name is also deemed a user in the report.
The following variations of a user report can be run:
By Group
Each user group is displayed on a separate tab: move between the tabs using the Next Group/Previous Group options.
Note: When exported, all tabs are displayed on the same report.
By User
All catalog users are displayed on the same tab.
In Declared Order
All catalog users are displayed on the same tab, and grouped within their user groups.

This report can also be run from Relativity DBA if the group\user is granted reporting privileges.

Parent topic: Reporting
Related tasks
Running and Exporting Reports


Connections Reports

The Connections report category provides detailed information about the association of SQL table names and the file physical access names maintained in a Relativity catalog.

This report can also be run from Relativity DBA if the group\user is granted reporting privileges.

Parent topic: Reporting
Related tasks
Running and Exporting Reports


Privileges Reports

The Privileges report category provides detailed information about database, table, and column privileges maintained in a Relativity catalog.

This report can also be run from Relativity DBA if the group\user is granted reporting privileges.

Parent topic: Reporting
Related tasks
Running and Exporting Reports


Reference Information

  • Database Logon Window
    The Database Logon dialog box appears when you start the Relativity DBA that contains one or more databases.
  • File Menu Commands
    The commands displayed on the File menu of the Relativity DBA window depend on whether a data source has been opened and selected for processing.
  • Tools Menu Commands
    The Tools menu of the Relativity DBA window contains a wide range of options for all facets of Relativity DBA.
  • Help Menu Commands
    The Help menu of the Relativity DBA window contains links to version details, and the Help files associated with Relativity DBA.
  • SQL Reserved Words
    There are a number of SQL reserved words that you are prevented from using for your column and table names.
Parent topic: Micro Focus Relativity DBA for Windows


Database Logon Window

The Database Logon dialog box appears when you start the Relativity DBA that contains one or more databases.

It enables you to connect to the last database catalog that was accessed in your previous session. If you want to log on to a different database, you can click Cancel, where you are taken to the Relativity DBA main window, and if configured to display, the Start page.

The Database Logon dialog box contains the following options:

Option | Description
UserId | Enter user the user name of a user that belongs to one of the groups associated with the database catalog.
Password | Enter the password that corresponds to the user name entered.
Login | Click Login to log on to the last database accessed, after entering valid logon credentials
Cancel | Click Cancel to cancel logon to the last database accessed. The main Relativity DBA window is then displayed, enabling you to log on to other databases.
Parent topic: Reference Information


File Menu Commands

The commands displayed on the File menu of the Relativity DBA window depend on whether a data source has been opened and selected for processing.
Option | Description
Connect to <data-source> | Connects to the last database you were logged on to. Enter valid logon credentials when prompted, to load the catalog.
Connect to Existing Data Source | Displays the Open Existing Data Source dialog box, which enables you to select an existing data source. Enter valid logon credentials when prompted, to load the catalog.
Create New Data Source | Displays the Create new Data Source dialog box, which enables you to add a new Relativity data source. For more information, see Setting up a New Data Source.
Close Current Data Source | Closes the current data source, as identified in the Current DSN box in the top-right of the Relativity DBA window. Any tab that is open that contains data source information is also closed.
Exit | Terminates the execution of the Relativity DBA.
Parent topic: Reference Information


Tools Menu Commands

The Tools menu of the Relativity DBA window contains the following commands.

Option | Description
Start Page | Displays the Start Page tab, which displays an introduction to Relativity, and quick links to some common tasks you may require. You can configure this page to display automatically when you open Relativity DBA; see the Options > General tab.
Options | Display the Options tab, which is a collection of further tabs covering various preferences for the Relativity DBA. These settings become the default settings for the appropriate options. See Setting Options.
Date Constants Displays the Date Constants tab, which enables you to change the values of the following:
  • The four date constants, 'Days' Base Date, 'YYYY' Base Year, 'YY' Century Cutoff, and 'YY' Base Year.
  • The structure of two date constants ('YY' Dates and 'YYYY' Dates).
For more details, see Defining Date Constants.
Character Sets | Displays the Character Sets tab, which lists the character sets in use in a Relativity data source. This tab also allows you to add both standard and nonstandard character sets to the current Relativity data source, and modify the character set associated with file definitions. See Maintaining Character Sets and Defining Nonstandard Character Sets.
Theme | Enables you to pick from a number of themes that can be applied to the look of the Relativity DBA window.
Parent topic: Reference Information
Related reference
Defining Date Constants


Help Menu Commands

The Help menu of the Relativity DBA window contains the following commands.

Option | Description
Contents | Launches the Relativity DBA Help file.
DBMS Help File | Launches the Relativity Data Manager (DBMS) Help file.
About | Display the About dialog box, which includes the version number, copyright specifications, catalog version number, and licensing information of the Relativity DBA product that is currently running.
Parent topic: Reference Information


SQL Reserved Words

The following table contains a list of SQL reserved words that Relativity prevents you from using as a column name or table name when creating a new table. This is necessary because some ODBC-enabled applications can not handle these words as column or table names.

ADD

ALL

ALTER A

AND

ANY

AS

ASC

AVG

BETWEEN

BY

CASCADE

CHECK

COUNT

CREATE

CROSS

DEFAULT

DELETE

DESC

DISTINCT

DROP

EXISTS

FOREIGN

FROM

FULL

GRANT

GROUP

HAVING

IF

IN

INDEX

INNER

INSERT

INTO

IS

JOIN

KEY

LEFT

LIKE

MAX

MIN

NOT

NULL

ON

OR

ORDER

OUTER

PRIMARY

PUBLIC

REFERENCES

RESTRICT

REVOKE

SELECT

SET

SUM

SVBEGIN

SVEND

TABLE

TO

UNION

UNIQUE

UPDATE

USER

VALUES

VIEW

WHERE

Parent topic: Reference Information


Glossary of Terms

The glossary terms used in Relativity are listed below alphabetically.
  • 88-level
  • catalog
  • Character Set
  • COBOL Name property
  • COBOL table
  • coinciding OCCURS
  • CombineDateTime
  • Comment property
  • Complement
  • ComputeCenturyDate
  • ComputeCenturyDateTime
  • ComputeDateTime
  • ComputeODO
  • ComputeTime
  • condition item
  • condition-name
  • conditional variable
  • Constrain property
  • custom data types
  • Custom Data Type property
  • data item
  • data source
  • data-name
  • database
  • date constants
  • Default Column Name property
  • entered numerics
  • domain
  • file label item
  • filter subexpression
  • filter
  • function item
  • function
  • Hexadecimal condition values
  • indexed file
  • internal function
  • ISAM file
  • IsNumeric
  • IsValidDate
  • item set
  • LogicalAnd
  • LogicalOr
  • Not Null property
  • null
  • Null Value property
  • nullable
  • ODBC data type
  • ODBC-enabled application
  • ODBC
  • ODO control item
  • Open Database Connectivity
  • property
  • RDBMS
  • record type filter
  • record type
  • Redefined By property
  • Redefines property
  • redundant data items
  • relational database management system
  • relational database
  • relational table
  • Relativity Data Client
  • Relativity Data Manager
  • Relativity Data Server
  • Relativity DBMS
  • repeating data item
  • SQL
  • Standard character sets
  • Structured Query Language
  • subscript item
  • subscripted data item
  • table
  • table definition
  • table filter
  • table name
  • transform
  • Transform property
  • Value property
Parent topic: Micro Focus Relativity DBA for Windows


88-level

A means of defining a condition-name in COBOL data description entries.

Parent topic: Glossary of Terms
Related reference
condition-name
Complement
internal function
conditional variable
Constrain property
data item
LogicalAnd
LogicalOr
record type
record type filter


catalog

The function of the Relativity catalog is similar to that of the "system catalog" in a relational database management system. It serves as a repository for information regarding the structure of relational tables as well as operational information required by runtime components of Relativity, such as the Query Optimizer.

Additionally, the Relativity catalog contains complete information regarding the physical COBOL data file structure (that is, the COBOL file definition, or FD information) and information produced by the database design process (Relativity Designer) that defines the association between COBOL data files and data elements, and the relational tables and their constituent columns. Together, all of this information allows Relativity to present the COBOL data files through the ODBC interface of an ODBC-enabled application as a Relativity database of well-normalized tables substantially independent of the original COBOL data file structure of the application. See also Relativity DBMS and relational table.

Parent topic: Glossary of Terms
Related reference
relational database management system
ODBC-enabled application
ODBC
Relativity DBMS
data source
database
date constants
data item
internal function
SQL
transform


Character Set

Typically, a character set is a collection of graphical symbols, called Glyphs, which are used to communicate in a language. In order to represent the Glyphs in a computer, they must be associated with a numerical value, called a Code Point, for storage. In modern computers, the Code Points are stored in individual, 8-bit bytes of memory allowing 256 Glyphs to be represented. Relativity uses the term "character set" to refer to Glyphs and their associated Code Points.

On IBM PCs, the term "Code Page" is commonly used to describe this mapping of Glyphs to Code Points. However, on UNIX-based machines, it is more common to use the ISO 8859 standard to describe this mapping. Relativity provides character sets for both of these standards.

Relativity uses the character set of each file in order to interpret the Code Points stored within it. For example, if your data is in English and resides on Windows or DOS, selecting the character set for Code Page 437 would be appropriate. If your data is in English and resides on UNIX, the character set for ISO 8859-1 (otherwise known as Latin 1) would be appropriate.

Parent topic: Glossary of Terms


COBOL Name property

The COBOL Name property is the name of the FD entry and the data description entries for each record in the COBOL data file. The following items are displayed as the COBOL Name properties for data items in the FD form.

  • FD level indicator followed by a COBOL data filename.
  • Level-number 01 followed by a COBOL record-name.
  • Level-number 02 and above followed by the COBOL data-name of a group data item or elementary data item.
  • Function items defined by Func: followed by the name of the internal function.
  • A subscript item defined by SUBSCRIPT OF followed by the name of the item of which it is subscript.

Indentation of the abbreviated data descriptions gives a visual representation of the hierarchical structure of the data items contained in the record.

Parent topic: Glossary of Terms


COBOL table

A COBOL group or elementary data item described with the OCCURS clause. Contrast with relational table. See also table and repeating data item.

Parent topic: Glossary of Terms
Related reference
data item
repeating data item
table
relational table
database
subscripted data item
subscript item
table filter


coinciding OCCURS

Two or more separate OCCURS clauses in a record description entry that each specify the same number of occurrences and where the COBOL tables created by the OCCURS clauses can be thought of as really being a single COBOL table accessed by a single subscript item.

Parent topic: Glossary of Terms
Related reference
subscript item
table


CombineDateTime

An internal function that allows two data items to be combined into a single date/time stamp value. The first argument should be a date data item. The second argument should be a time data item.

The YYYYMMDDHHMMS transform may be applied to resulting data item.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


Comment property

In the FD form, the Comment property contains comments pertaining to the data item defined by this row in the FD form. The comment is changed by clicking in the grid cell. See Specifying Comments for more information.

This property is totally owned by the catalog developer for use in the Relativity Designer. It is a good place to maintain a user-friendly definition of the data item. Another use of this property might be to discuss the uses of a data item that may not be obvious.

Parent topic: Glossary of Terms
Related reference
Specifying Comments


Complement

An internal function that performs an arithmetic complement on a numeric data item. The first argument is the data item to be complemented; the second argument is an 88-level condition-name. If the 88-level condition-name value is false, the arithmetic complement is not performed.

Parent topic: Glossary of Terms
Related reference
88-level
condition-name
internal function


ComputeCenturyDate

The ComputeCenturyDate internal function computes a date from data items and/or constants containing the century, the year of the century, the month, and the day of the month or year. When a constant zero is supplied for the month, ComputeCenturyDate computes a date from data items and/or constants containing the year and the days of the year.

The YYYYMMDD transform may be applied to resulting data item.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


ComputeCenturyDateTime

The ComputeCenturyDateTime internal function computes a date and time data item from data items and/or constants containing the century, the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


ComputeDateTime

An internal function that computes a date and time data item from data items and/or constants containing the year, the month, the day of the month or year and optional data items or constants containing the hour or the day, the minute of the hour, the second of the minute, and the hundredth of the second.

The YYYYMMDDHHMMSShh transform may be applied to the resulting data item.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


ComputeODO

An internal function that computes an occurrence count from the record length, the record offset of the (single) argument, and the length and span of the argument. The argument must be a repeating data item at the end of the record.

Parent topic: Glossary of Terms
Related reference
internal function
repeating data item


ComputeTime

An internal function that computes a time data item from data items and/or constants containing the hour of the day, the second of the minute, and the hundredth of the second.

The HHMMSShh transform may be applied to the resulting data item.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


condition item

A named subset of values that a conditional variable may assume. The condition item is true when the conditional variable assumes any of the true values. The condition item is false when the conditional variable assumes any other value. A condition item may optionally specify a single preferred value for which the condition item is false when the conditional variable assumes that value. The declaration of a condition item includes a condition-name that is used to refer to the condition item.

In Relativity, a column may be defined on a condition item, in which case the column has a value of 0 for false, and 1 for true. Relativity also uses condition items for specifying null values, specifying filters, and binding subscripts. To help support these uses of condition items, the Relativity Designer allows definition of additional condition items that were not in the COBOL source program.

Parent topic: Glossary of Terms
Related reference
condition-name
null
conditional variable
data item
SQL


condition-name

A user-defined word that names a condition item. In COBOL, a condition-name is declared in an 88-level description entry following the data description entry of its associated conditional variable.

Note: Relativity does not make use of the alternative COBOL meaning of condition-name where the condition-name is assigned to the status of a switch or device.
Parent topic: Glossary of Terms
Related reference
88-level
Complement
internal function
condition item
null
conditional variable
Constrain property
data item
filter subexpression
filter
LogicalAnd
LogicalOr
record type
record type filter


conditional variable

A data item that has one or more condition-names associated with it. The value of the conditional variable is used to determine whether the condition item named by the condition-name is true or false by comparing it to the values assigned to the condition-name.

Parent topic: Glossary of Terms
Related reference
condition-name
88-level
data item
condition item


Constrain property

A property that limits the value that a column may have during an INSERT or UPDATE operation to one of the true values indicated by an 88-level condition-name defined on the data item associated with the column. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s).

Parent topic: Glossary of Terms
Related reference
88-level
condition-name
data item


custom data types

A Relativity representation of a domain. A custom data type, which is defined by the user, is a named set of properties for a column, including its ODBC data type, length, default value, whether the column allows null values, whether the column is constrained to certain values, and, for numeric type columns, the precision and scale. After a custom data type is defined, it can be used in place of ODBC data types in column definitions, thus giving all columns with the same user data type similar characteristics.

Parent topic: Glossary of Terms
Related reference
domain
ODBC data type
data-name
transform
ODBC
relational table
null


Custom Data Type property

In the FD form, the Custom Data Type property is the user data type that will be assigned by the Relativity Designer when the data item is used as a column in a table. Assign default data types to data items in the FD form by selecting the appropriate type in the Custom Data Type column.

Parent topic: Glossary of Terms
Related reference
Defining a User Data Type


data item

A named unit of data (excluding literals) defined by the COBOL program in a data description entry. The declaration of a data item includes a data-name that is used to refer to the data item. The Relativity Designer allows additional data items to be defined that redefine data items defined by the COBOL source program. See also repeating data item.

Parent topic: Glossary of Terms
Related reference
function
internal function
transform
COBOL table
repeating data item
table
CombineDateTime
ComputeCenturyDate
ComputeCenturyDateTime
ComputeDateTime
ComputeTime
conditional variable
condition item
Constrain property
88-level
condition-name
data-name
database
catalog
date constants
data source
SQL
function item
Relativity DBMS
ODO control item
record type
record type filter


data source

In Relativity, a data source is the connection known to ODBC between a Windows workstation and a Relativity catalog. A data source name (DSN) is used to identify the data source on the workstation. See also database and ODBC-enabled application.

Note: In client/server configurations of Relativity, a data source is defined on both the client workstation and on the server. The client data source is known to ODBC by its DSN and specifies the connection to the server data source. The server data source provides the connection to the Relativity catalog.
Parent topic: Glossary of Terms
Related reference
catalog
ODBC-enabled application
ODBC
database
date constants
data item
Relativity DBMS
SQL
relational database


data-name

A user-defined word that names a data item.

Parent topic: Glossary of Terms
Related reference
data item
repeating data item
domain
transform
custom data types
item set
redundant data items
relational table
ODO control item


database

In this document, particularly when qualified by "Relativity", a database refers to a relational database of tables and columns accessible as an ODBC data source, where the value for a column is derived from a data item in a COBOL file. An ODBC data source name is used to refer to the database, indirectly through the Relativity catalog that describes the database. The Relativity Designer is used to create and maintain the catalog. The Relativity DBA may be used to maintain a subset of the catalog relating to end-user administration features such as table connections, security, and date constants.

Parent topic: Glossary of Terms
Related reference
data source
catalog
ODBC-enabled application
ODBC
date constants
data item
Structured Query Language
relational database
relational database management system
relational table
COBOL table
table


date constants

Values stored in the Relativity catalog that control the conversion in a date transform or an internal function of COBOL data item values to SQL column date values. The date constants can be adjusted using the Relativity Designer or Relativity DBA to reflect common algorithms used in COBOL procedural code.

Parent topic: Glossary of Terms
Related reference
database
catalog
data item
data source
internal function
SQL
transform


Default Column Name property

In the FD form, the Default Column Name property is the SQL column name that will be assigned by the Relativity Designer when the data item is used as a column in a table. When the Default Column Name property is first generated, it is derived from the COBOL data-name according to a set of rules for defining default column names.

The column name may be changed after a column is created by using the Column Name property in the Table form.

Column names may not be SQL reserved words.

Parent topic: Glossary of Terms


entered numerics

When adding condition items, if you are specifying an Entered numeric value, enter the COBOL numeric literal for the associated value. For example, 489, +12.75, -3.28, or -3.22E+12. The leading sign character is allowed only if the associated data item is signed. The decimal point is allowed only if the associated data item has digits to the right of the decimal point. The exponential notation is allowed only for associated data items with floating point numbers.

An Entered nonnumeric value is specified in the text box as the string of characters against which the conditional variable is to be compared. It is similar to a COBOL nonnumeric literal, except that the delimiting quotes are omitted and embedded quote characters are not doubled (that is, each occurrence of a quote character in the string represents one quote character in the resultant value as opposed to a COBOL nonnumeric literal where each pair of quote characters represents one quote character in the resultant value).

Parent topic: Glossary of Terms


domain

A named set of characteristics of a column including the data type, default value, constraints on the values in the column, and whether null values are allowed for the column. See also ODBC data type, and user data type.

Parent topic: Glossary of Terms
Related reference
ODBC data type
custom data types
data-name
transform
null


file label item

A file label item is a special file definition item used in multi-file table support. Multi-file table support allows the records of more than one COBOL file to be combined to constitute the rows of a single table. A file label item controls the way in which the records are combined, and provides a way to distinguish the business unit from which the row originated in the ODBC application.

A given FD may have only one file label item. A file label item can have a column defined on it and this column will be part of the indexes defined on the table.

Parent topic: Glossary of Terms
Related reference
ODBC
table


filter subexpression

A connecting logical operator (AND or OR), an optional negation logical operator (NOT), and a condition-name used to compose a filter expression that specifies the condition under which a record passes through the filter. If a filter has no subexpressions, then all records pass through the filter.

Parent topic: Glossary of Terms
Related reference
filter
condition-name
record type filter
table
table filter


filter

A set of criteria applied to records in order to obtain a subset of records that will be used to supply rows to a table. Relativity uses two types of filters: record type filter and table filter. Relativity filters use an expression composed of a filter subexpression or several filter subexpressions to specify the condition under which a record passes through the filter.

Parent topic: Glossary of Terms
Related reference
filter subexpression
condition-name
record type filter
table
table filter


function item

A data item that has been synthesized using an internal function.

Parent topic: Glossary of Terms
Related reference
internal function
data item


function

See internal function.

Parent topic: Glossary of Terms
Related reference
data item
internal function
transform


Hexadecimal condition values

When adding condition items, if you are specifying a Hexadecimal value, it is specified as a string of pairs of hexadecimal digits (0-9, A-Z), where each consecutive pair of hexadecimal digits specifies one character of the resultant value. For example, the string 0A0D would represent a value containing the ASCII character NL (newline) followed by CR (carriage return), the string 48494A4B would represent a conditional value containing the ASCII string HIJK, and the string F7F3F9 would represent a value containing the EBCDIC string 739. The Hexadecimal option is only allowed for nonnumeric data items.

Parent topic: Glossary of Terms


indexed file

A file having a permanent logical file structure in which each record is identified by a value of one or more keys within that record.

Parent topic: Glossary of Terms
Related reference
ISAM file


internal function

A conversion process, built into Relativity DBMS, that is used to synthesize a COBOL data item using the value or values of one or more other COBOL data items within the same COBOL file definition (FD). The other COBOL data items, which may include a previously defined internal function, are specified as arguments to internal functions. The result of the internal function is used as the value for the synthesized COBOL data item, also known as a function item. Unlike a transform, an internal function may operate on more than one COBOL data item. Compare to transform.

Parent topic: Glossary of Terms
Related reference
data item
function
transform
CombineDateTime
Complement
88-level
condition-name
ComputeCenturyDate
ComputeCenturyDateTime
ComputeDateTime
ComputeODO
repeating data item
ComputeTime
date constants
catalog
SQL
function item
Relativity DBMS
IsNumeric
IsValidDate
LogicalAnd
LogicalOr


ISAM file

A term used to refer to an indexed file.

Parent topic: Glossary of Terms
Related reference
indexed file


IsNumeric

An internal function that evaluates the data item supplied as an argument to determine whether its value is a valid numeric value. If the data item is numeric, the function returns the value one, which is the logical value of true. If the data item is not numeric, the function returns the value zero, which is the logical value of false.

The IsNumeric internal function evaluates the data item supplied as an argument to determine whether its value is a valid numeric value. If the data item is numeric, the function returns the value 1, which is the logical value of true. If the data item is not numeric, the function returns the value 0, which is the logical value of false.

Parent topic: Glossary of Terms
Related reference
internal function


IsValidDate

An internal function that evaluates the data item supplied as an argument to determine whether its value conforms to that item’s date transform. If the date item value represents a valid date, the function returns the numeric value one, which is the logical value of true. If the data item value does not represent a valid date, the function returns the numeric value zero, which is the logical value of false.

The IsValidDate internal function evaluates the data item supplied as an argument to determine whether its value conforms to that item’s date transform. If the date item value represents a valid date, the function returns the numeric value 1, which is the logical value of true. If the data item value does not represent a valid date, the function returns the numeric value 0, which is the logical value of false.

Parent topic: Glossary of Terms
Related reference
internal function


item set

Two or more data items in a COBOL record that contain identical information but that have been identified to Relativity as sets of redundant data items. Redundant data items include situations such as where one data item is identical to the first characters of another data item. One place where redundant data items are defined is in keys, where different keys provide different look-up capabilities in a file. Using Relativity, an item set becomes one data item in a relational table.

Parent topic: Glossary of Terms
Related reference
data-name
redundant data items
relational table


LogicalAnd

The LogicalAnd internal function does a logical "and" operation on two to twenty 88-level condition-names or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If all of the arguments are true, the function returns the numeric value 1, which is the logical value of true. If any of the arguments are false, the function returns the numeric value 0, which is the logical value of false.

Parent topic: Glossary of Terms
Related reference
88-level
condition-name
internal function


LogicalOr

The LogicalOr internal function does a logical "or" operation on two to twenty 88-level condition-names or logical internal functions (IsNumeric, LogicalAnd, LogicalOr). If any of the arguments are true, the function returns the numeric value 1, which is the logical value of true. If all of the arguments are false, the function returns the numeric value 0, which is the logical value of false.

Parent topic: Glossary of Terms
Related reference
88-level
condition-name
internal function


Not Null property

In the FD form, the Not Null property, when set, indicates that an SQL column defined on this item is null when the null condition is false. The Not Null property is initially not set, indicating that an SQL column defined on this item is Null when the Null condition is true. See Defining Null Information.

Parent topic: Glossary of Terms


null

A value used in SQL to indicate that the column data value is incorrect, inapplicable, or unavailable. See also condition item and null.

Parent topic: Glossary of Terms
Related reference
condition item
condition-name
SQL
nullable
ODBC data type
custom data types
domain


Null Value property

In the FD form, the Null Value property describes the data value that will produce a null, or will be stored when a null is written, in an SQL column using this data item. The representation of a null for a data item in the FD form is selected from a list of condition-names. The conditional variable associated with a condition-name in the list does not have to be the data item on the FD form for which the Null Value property is being defined. See Defining Null Information.

Parent topic: Glossary of Terms


nullable

An indicator that the column data value may be set to null.

Parent topic: Glossary of Terms
Related reference
null
ODBC data type


ODBC data type

An SQL definition that governs the type of data that is valid for a column in a relational table. The following lists the data type names preassigned to ODBC data types in Relativity:

  • Exact numeric data types are bit, smallint, integer, and decimal.
  • Approximate numeric data types are single and double.
  • Character (or text) data types are char, varchar, and longvarchar.
  • Unstructured binary data type is longvarbinary.
  • Date/time data types are date, time, and timestamp.

The preassigned data type names for the ODBC data type appear in a bold font on the Table form. See also user data type.

Parent topic: Glossary of Terms
Related reference
domain
custom data types
nullable
null


ODBC-enabled application

A Windows-based client application program (or tool) that has been designed to use the ODBC interface to access data external to the application. The ODBC interface requires that a data source be configured in order to allow data access. Examples of such programs include MS-Access, MS-Excel, Lotus 1,2,3, Crystal Reports, PowerBuilder, and so forth.

Parent topic: Glossary of Terms
Related reference
catalog
relational database management system
ODBC
Relativity DBMS
data source
database
Structured Query Language
Relativity Data Client
Relativity Data Server
SQL
relational database


ODBC

Abbreviation for Open Database Connectivity, a Microsoft Windows interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). See also ODBC-enabled application.

Parent topic: Glossary of Terms
Related reference
catalog
relational database management system
ODBC-enabled application
Relativity DBMS
data source
database
file label item
table
relational table
custom data types
Structured Query Language
SQL
transform


ODO control item

The data item referenced by the data-name specified in the DEPENDING ON phrase of the OCCURS clause.

Parent topic: Glossary of Terms
Related reference
data-name
data item


Open Database Connectivity

A Microsoft interface allowing applications to access data in database management systems (DBMS) using Structured Query Language (SQL). Abbreviated ODBC.

Parent topic: Glossary of Terms
Related reference
SQL


property

The term property refers to information about a Relativity form, such as the: FD form, Table form, Edit Users form, or Edit Privileges form.

Parent topic: Glossary of Terms


RDBMS

Abbreviation for relational database management system, a program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). See also Relativity DBMS.

Parent topic: Glossary of Terms
Related reference
relational database
Relativity DBMS
SQL


record type filter

A filter associated with a record type that determines the conditions controlling the subset of records from the file that conform to that record type. When a table is based on the record type, only records that satisfy the specified conditions contribute rows to that table. Those records may be further filtered by a table filter if a table filter is associated with the table. Record type filters are specified on the Record Type Properties form accessed from the FD form in the Relativity Designer.

Parent topic: Glossary of Terms
Related reference
filter
filter subexpression
table
table filter
record type
88-level
condition-name
data item


record type

A particular layout of a record area when multiple layouts exist because of redefinition or varying interpretation of data items in the record area. Normally, record types are distinguished by a record type indicator data item that is either outside any redefinition or exists in every redefinition. Relativity uses an 88-level condition-name defined on the record type indicator to distinguish record types. If the program did not define the appropriate 88-level condition-name(s), the Relativity Designer may be used to add the necessary condition-name(s). See also record type filter.

Parent topic: Glossary of Terms
Related reference
88-level
condition-name
data item
record type filter


Redefined By property

In the FD form, the Redefined By property is the COBOL data-name of any data item having a data description with the REDEFINES clause that specifies this data item. See Redefining Data Items and Defining Record Types.

Parent topic: Glossary of Terms


Redefines property

In the FD form, the Redefines property is the COBOL data-name that appears in the REDEFINES clause of the data description for a data item that contains the REDEFINES clause. See Redefining Data Items and Defining Record Types.

Parent topic: Glossary of Terms


redundant data items

See item set.

Parent topic: Glossary of Terms
Related reference
item set
data-name
relational table


relational database management system

A program or set of programs for managing a relational database. Such a system normally includes a query capability that implements a query language. A common choice for the query language is Structured Query Language (SQL). Abbreviated RDBMS. See also Relativity DBMS.

Parent topic: Glossary of Terms
Related reference
catalog
ODBC-enabled application
ODBC
Relativity DBMS
SQL
relational database
database


relational database

A type of database that defines multiple and complex relations among different data using tables (rows and columns of data). In a relational database, the rows of a table represent records (collections of information about separate items) and columns represent data items (particular attributes of a record). Relationships among data items are not physically stored. Instead, data is stored in tables, and relationships between two or more records are established by matching the values of columns common to those tables. See also relational database management system.

Parent topic: Glossary of Terms
Related reference
RDBMS
Relativity DBMS
SQL
database
relational database management system
Relativity Data Manager
Relativity Data Server
data source
ODBC-enabled application


relational table

A set of rows where each row contains the same number of columns. In any one column of a table, all the rows have the same value type in that column. Contrast with COBOL table. See also database and table.

Parent topic: Glossary of Terms
Related reference
item set
data-name
redundant data items
ODBC
custom data types
COBOL table
database
table
table definition
table filter


Relativity Data Client

The Relativity Data Client is the component of the Relativity DBMS that resides on the Windows client machine and provides the ODBC interface for the two-tier or client/server configuration of Relativity. ODBC-enabled applications running on the client machine access Relativity data on the server machine using the interface implemented in the Data Client. The Data Client is, essentially, the ODBC Driver for Relativity in this configuration. See also Relativity Data Server.

Parent topic: Glossary of Terms
Related reference
ODBC-enabled application
Relativity DBMS
Relativity Data Server


Relativity Data Manager

The Relativity Data Manager is used in the single-tier (or non-client/server) configuration of Relativity where the complete Relativity DBMS resides on a single Windows machine. This component implements the ODBC interface, the file to relational database transformations, and the application data file access routines. All the data files to be accessed must be accessible from the Windows machine, either because the files exist on disk drives attached to that machine or are accessible using the Windows network file system.

Parent topic: Glossary of Terms
Related reference
relational database
Relativity DBMS


Relativity Data Server

The Relativity Data Server is the component of a two-tier or client/server Relativity DBMS that resides on the remote server machine and implements the file to relational database transformations and the application data file access routines. This component runs on the remote machine that has access to the COBOL data files, either directly or through the network file system of the remote machine. See also Relativity Data Client.

Parent topic: Glossary of Terms
Related reference
Relativity Data Client
ODBC-enabled application
Relativity DBMS
relational database


Relativity DBMS

The Relativity DBMS (Database Management System) is software that implements an ODBC-compliant and relational database view of actual, operational COBOL data files. The Relativity DBMS also can take instructions from the ODBC-enabled application to access and change data in the COBOL data files. The ODBC-enabled application issues a high-level command, called an SQL statement, describing the data that the application wants to access. The Relativity DBMS performs the same actions a COBOL program would perform in order to extract that data and then returns the data to the ODBC-enabled application in the form of "rows".

The Relativity DBMS comes in two different configurations. In the single-tier or non-client/server configuration, the complete Relativity DBMS resides on a single Windows machine. The single-tier configuration component of the Relativity DBMS is referred to as the Relativity Data Manager. In the two-tier or client/server configuration, the Relativity DBMS is split into two components so that the DBMS can reside on two machines. The two-tier components of the Relativity DBMS are referred to as the Relativity Data Client and the Relativity Data Server. See also data source and catalog.

Parent topic: Glossary of Terms
Related reference
catalog
relational database management system
ODBC-enabled application
ODBC
internal function
data item
transform
RDBMS
relational database
SQL
Relativity Data Client
Relativity Data Server
Relativity Data Manager
data source


repeating data item

A data item having a data description entry that either contains the OCCURS clause or is subordinate to a data description entry that contains the OCCURS clause. See COBOL table. A repeating data item is also referred to as a subscripted data item, since such data items generally require a subscript when specified in COBOL source statements.

Parent topic: Glossary of Terms
Related reference
COBOL table
data item
table
ComputeODO
internal function
data-name
subscripted data item
subscript item


SQL

Abbreviation for Structured Query Language, a language to access data in a database management system (DBMS). See also ODBC.

Parent topic: Glossary of Terms
Related reference
date constants
catalog
data item
internal function
transform
null
condition item
Open Database Connectivity
RDBMS
relational database
Relativity DBMS
relational database management system
data source
ODBC-enabled application
ODBC
table name


Standard character sets

Windows Latin 1

Windows Latin 2

Windows Latin 5

Windows Cyrillic

Windows Greek

Windows Baltic Rim

Windows Hebrew

Windows Arabic

MS-DOS Latin US

MS-DOS Latin 1

MS-DOS Latin 2

MS-DOS Cyrillic

MS-DOS Cyrillic CIS-1

MS-DOS Turkish

MS-DOS Portuguese

MS-DOS Icelandic

MS-DOS French Canada

MS-DOS Greek

MS-DOS Greek 1

MS-DOS Greek 2

MS-DOS Baltic Rim

MS-DOS Russian

MS-DOS Arabic

MS-DOS Arabic ASMO

MS-DOS Hebrew

EBCDIC US Canada

EBCDIC International

EBCDIC Greek

EBCDIC Latin 5 Turkish

ISO 8859-1

ISO 8859-2

ISO 8859-5

ISO 8859-6

ISO 8859-7

ISO 8859-8

Parent topic: Glossary of Terms


Structured Query Language

A language to access data in a database management system (DBMS). Abbreviated SQL. See also ODBC.

Parent topic: Glossary of Terms
Related reference
ODBC
database
ODBC-enabled application


subscript item

A data item created by the Relativity Designer for each COBOL table. A subscript item, while not an actual part of the record, represents the subscript used to access repeating data items in the record. A column may be based on the subscript item by dragging the subscript item to a relational table in the Table form. Subscript items are given the data-name "SubscriptItem", and they are shown in the FD form immediately following any data item described with the OCCURS clause.

Parent topic: Glossary of Terms
Related reference
coinciding OCCURS
table
repeating data item
COBOL table


subscripted data item

A repeating data item (q.v.).

Parent topic: Glossary of Terms
Related reference
repeating data item
COBOL table


table

In Relativity, a table is usually a relational table composed of rows and columns. In certain cases, made clear by explicit qualification or context, a table is a COBOL table of repeating data items defined by use of the OCCURS clause. See also table filter.

Parent topic: Glossary of Terms
Related reference
COBOL table
data item
repeating data item
file label item
ODBC
filter
filter subexpression
record type filter
table filter
coinciding OCCURS
subscript item
relational table
database


table definition

A table definition is created by the Relativity Designer to define the structure of a relational table associated with a COBOL data file.

Parent topic: Glossary of Terms
Related reference
table name
relational table


table filter

A filter associated with a table that determines the conditions controlling the subset of records from the file that contribute rows in that table. If the table is based on one or more record types, the table filter is applied after the record type filters, if any, associated with those record types. A table filter is appropriate when either record types are not used or the table is a subset of the records belonging to the record type upon which the table is based.

Table filters are specified on the Table Filter Properties pane accessed from the table definition form.

Parent topic: Glossary of Terms
Related reference
filter
filter subexpression
record type filter
table
COBOL table
table filter
relational table


table name

A table name is the name of an SQL table.

Parent topic: Glossary of Terms
Related reference
table definition
SQL


transform

A process of converting a single COBOL data item value to or from a relational database column value. An example would be taking a COBOL PIC 9(8) data item that contains 19970129 and converting it to an ODBC date column that contains January 29, 1997. Compare to internal function.

Parent topic: Glossary of Terms
Related reference
data item
function
internal function
CombineDateTime
ComputeCenturyDate
ComputeCenturyDateTime
ComputeDateTime
ComputeTime
date constants
catalog
SQL
Relativity DBMS
domain
data-name
custom data types
ODBC


Transform property

In the FD form, the Transform property specifies a data transformation for a COBOL data item value to and/or from a relational database column value. Change the transform in the Transform property by clicking in the grid cell and then selecting a transform from the list.

The choices available in the Transform column are determined by the settings selected on the Date Format tab in the Options pane.

Parent topic: Glossary of Terms
Related reference
Defining Transforms on Data Items
Transforms


Value property

In the FD form, the Value property displays the value in the VALUE clause of a condition-name or the argument list of a function item. Click on the item row in the FD form to see the complete value entry in the Value property; see Adding Condition Items.

Parent topic: Glossary of Terms


Copyright and Legal Information

  • Copyright and Trademarks
Parent topic: Micro Focus Relativity DBA for Windows


Copyright and Trademarks

© Copyright 1984 - 2021 Micro Focus or one of its affiliates. The software and information contained herein are proprietary to, and comprise valuable trade secrets of, Micro Focus, which intends to preserve as trade secrets such software and information. This software is an unpublished copyright of Micro Focus and may not be used, copied, transmitted, or stored in any manner other than as expressly provided in a written instrument signed by Micro Focus and the user. This software and information or any other copies thereof may not be provided or otherwise made available to any other person.

Micro Focus has made every effort to ensure that this book is correct and accurate, but reserves the right to make changes without notice at its sole discretion at any time. The software described in this document is supplied under a license and may be used or copied only in accordance with the terms of such license, and in particular any warranty of fitness of Micro Focus software products for any particular purpose is expressly excluded and in no event will Micro Focus be liable for any consequential loss.

Reference to third party companies, products and web sites is for information purposes only and constitutes neither an endorsement nor a recommendation. Micro Focus provides this information only as a convenience to users. Micro Focus makes no representation whatsoever regarding the content of any other web site or the use of any such third party products. Micro Focus shall not be liable in respect of your use or access to such third party products/web sites.

No part of this publication, with the exception of the software product user documentation contained on a CD-ROM, may be copied, photocopied, reproduced, transmitted, transcribed, or reduced to any electronic medium or machine-readable form without prior written consent of Micro Focus.

Licensees may duplicate the software product user documentation contained on a CD-ROM, but only to the extent necessary to support the users authorized access to the software under the license agreement. Any reproduction of the documentation, regardless of whether the documentation is reproduced in whole or in part, must be accompanied by this copyright statement in its entirety, without modification.

U.S. GOVERNMENT RESTRICTED RIGHTS. It is acknowledged that the Software and the Documentation were developed at private expense, that no part is in the public domain, and that the Software and Documentation are Commercial Computer Software provided with RESTRICTED RIGHTS under Federal Acquisition Regulations and agency supplements to them. Use, duplication or disclosure by the U.S. Government is subject to restrictions as set forth in subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer Software clause at DFAR 252.227-7013 et. seq. or subparagraphs (c)(1) and (2) of the Commercial Computer Software Restricted Rights at FAR 52.227-19, as applicable. Contractor is Micro Focus, One Irvington Center, 700 King Farm Boulevard, Suite 400, Rockville, Maryland 20850. Rights are reserved under copyright laws of the United States with respect to unpublished portions of the Software.

2021-05-07

Parent topic: Copyright and Legal Information